set names WIN1251;
set CLIENTLIB 'fbclient.dll';
connect 'd:\Smarket.fdb' user 'sysdba' password '3';

insert into scripts(name, makedate, developer, comment1)
  values('FB1352_quart_18_2_add3.sql', '30.07.2018', 14, '       II  2018 ');

ALTER TABLE CASH_LIST ADD WO_NDS T_INT_BOOLEAN_NULL;
COMMENT ON COLUMN CASH_LIST.WO_NDS IS ' " "';

update cash_list set wo_nds = 0;

ALTER TABLE CASH_LIST ALTER COLUMN WO_NDS TYPE T_INT_BOOLEAN;

set term ^ ;

CREATE OR ALTER TRIGGER CASH_LIST_BI FOR CASH_LIST
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (exists(select 1 from CONFIG where paramname = 'CashFixShop' and boolparam = 'T') and
      exists(select 1 from CASH_LIST where id_cash_list = new.id_cash_list))
    then exception e_cash_unique;

  if (new.cashkind is null) then new.cashkind = 1;
  if (new.placeindex is null) then begin
    new.placeindex = -1; new.filialindex = -1;
  end else begin
    select filial from GET_FILIAL_FROM_PLACE(new.placeindex)
      into new.filialindex;
  end
  if (new.priceindex is null) then new.priceindex = -1;
  if (new.filialindex <> -1) then begin
    --   ,     shopindex-
    if (not exists(select 1 from TH_CLASSIF t where t.id_th_classif = new.filialindex and t.parent_id = new.shopindex))
      then new.filialindex = -1;
  end
  if (new.is_use is null) then new.is_use = 1;
  if (new.wo_nds is null or new.cashkind <> 4) then new.wo_nds = 0;
end^

CREATE OR ALTER TRIGGER DOCHEAD_OVS_AIUD_LOG FOR DOCHEAD_OVS
ACTIVE AFTER INSERT OR UPDATE OR DELETE POSITION 0
as
declare variable id integer;
declare variable kind integer;
declare variable o_status integer;
declare variable n_status integer;
declare variable v_clear integer;
declare variable v_msg varchar(255);
declare variable v_user integer;
declare variable v_str varchar(255);
begin
  if (not exists(select 1 from CUT)) then begin
    --   dochead  ovs_kind   
    if (inserting) then o_status = 0; else o_status = old.post_status;
    kind = -1;
    if (deleting) then begin
      id = old.dochead;
      select ovs_kind from OVS_STAGE where id = old.ovs_kind into :kind;
      n_status = 0;
    end else begin
      id = new.dochead;
      select ovs_kind from OVS_STAGE where id = new.ovs_kind into :kind;
      n_status = new.post_status;
    end
    if (kind in (-1, 0,1,2,3,4,5,6,7,8) and n_status <> o_status) then begin
      if (exists(select 1 from CONFIG where paramname = 'TruncLogDOCHEAD' and boolparam = 'T'))
        then v_clear = 1; else v_clear = 0;
      if (v_clear = 1) then begin
        select id from CUR_USER into :v_user;
        delete from log
          where object = 'DOCHEAD' and act = 'STATUS_OVS' || :kind and
                keys = cast(:id as varchar(64)) and manager = :v_user;
      end

      v_str = ''; v_msg = '';
      select name_post_status from POST_STATUS where id_post_status = :o_status into :v_str;
      select name_post_status from POST_STATUS where id_post_status = :n_status into :v_msg;
      insert into log(object, act, keys, comment)
        values('DOCHEAD', 'STATUS_OVS' || :kind, :id, :v_str || ' -> ' || :v_msg);
      select id from CUR_USER into :v_user;
      if (deleting) then begin
        if (kind = 0) then insert into log_ovs(manager,moddate,ovs_id,act,comment,object,id_dochead) values(:v_user,current_timestamp,old.ovs_kind,3,:v_str || ' ->','',old.dochead);
        if (kind = 7) then insert into log_ovs(manager,moddate,ovs_id,act,comment,object,id_dochead) values(:v_user,current_timestamp,old.ovs_kind,3,:v_str || ' -> ' || :v_msg,'',old.dochead);
      end
      else
      if (kind in (0,7)) then insert into log_ovs(manager,moddate,ovs_id,act,comment,object,id_dochead) values(:v_user,current_timestamp,new.ovs_kind,3,:v_str || ' -> ' || :v_msg,'',new.dochead);
    end
  end
end^

create or alter procedure XCASH_COMPARE_CASH (
    V_CASH1 T_FID,
    V_CASH2 T_FID,
    V_SESSION T_FID)
returns (
    RET T_CHAR)
AS
declare variable v_filialindex integer;
declare variable v_shopindex integer;
declare variable v_cashkind1 integer;
declare variable v_cashkind2 integer;
declare variable v_placeindex1 integer;
declare variable v_placeindex2 integer;
declare variable v_priceindex1 integer;
declare variable v_priceindex2 integer;
declare variable lf_proc1 t_str_value;
declare variable lf_proc2 t_str_value;
declare variable fi_1 integer;
declare variable fi_2 integer;
declare variable l_b1 integer;
declare variable l_b2 integer;
declare variable l_r1 integer;
declare variable l_r2 integer;
declare variable l_k1 integer;
declare variable l_k2 integer;
declare variable wo_nds1 integer;
declare variable wo_nds2 integer;

begin

  select v_num
    from PARAMS where session = :v_session and class = 'Common' and name = 'FilialIndex'
    into :v_filialindex;
  select parent_id from TH_CLASSIF where id_th_classif = :v_filialindex into :v_shopindex;

  --  
  select filialindex, cashkind, placeindex, loadfile_proc,
         load_personal_bar, load_razrez_kind, load_konsul_kind, wo_nds
    from CASH_LIST r where shopindex = :v_shopindex and id_cash_list = :v_cash1
  into :fi_1, :v_cashkind1, :v_placeindex1, :lf_proc1,
       :l_b1, :l_r1, :l_k1, wo_nds1;
  select filialindex, cashkind, placeindex, loadfile_proc,
         load_personal_bar, load_razrez_kind, load_konsul_kind, wo_nds
    from CASH_LIST where shopindex = :v_shopindex and id_cash_list = :v_cash2
  into :fi_2, :v_cashkind2, :v_placeindex2, :lf_proc2,
       :l_b2, :l_r2, :l_k2, :wo_nds2;

  --    
  if (fi_1 <> fi_2) then begin --          
    ret = 'F'; suspend; exit;
  end

  --       
  if (v_cashkind1 <> v_cashkind2) then begin
    ret = 'F'; suspend; exit;
  end

  if (v_placeindex1 <> v_placeindex2) then begin
    ret = 'F'; suspend; exit;
  end

  --  " "
  if (wo_nds1 <> wo_nds2) then begin
    ret = 'F'; suspend; exit;
  end

  --     
  if (lf_proc1 is null) then lf_proc1 = ''; else lf_proc1 = Upper(lf_proc1);
  if (lf_proc2 is null) then lf_proc2 = ''; else lf_proc2 = Upper(lf_proc2);
  --    (  )
  if (lf_proc1 <> '' or lf_proc2 <> '') then begin
    --         
    --     ,
    --      ,
    --     ,
    --         
    ret = 'F'; suspend; exit;
  end

  --    
  if (l_b1 <> l_b2) then begin
    ret = 'F'; suspend; exit;
  end
  --   (   /)
  if (v_cashkind1 in (3, 4)  and (l_r1 <> l_r2 or l_k1 <> l_k2)) then begin
    ret = 'F'; suspend; exit;
  end

  if (exists (select 1 from TMP_LOAD_SECTION
                where name = 'Goods' or name = 'Com7Goods' or name = 'Com7Pludiscquant' or
                      name = 'Com7Classlim' or name = 'Com7Classdiscs' or name = 'Com7Pludiscs' or
                      name = 'Com7Goods' or name = 'Environment' or name = 'Com7Discsum')) then begin
    --  
    select priceindex from XCASH_GET_LOAD_PRICE(:v_cash1, :v_shopindex, :fi_1) into :v_priceindex1;
    select priceindex from XCASH_GET_LOAD_PRICE(:v_cash2, :v_shopindex, :fi_2) into :v_priceindex2;
    if (v_priceindex1 <> v_priceindex2) then begin
      ret = 'F'; suspend; exit;
    end
  end

  --           
  --                
  if (exists(select 1 from CONFIG where paramname = 'UseSuperCash' and boolparam = 'T')) then begin
    --       
    if (exists(select 1
                 from SUPERCASH s1
                 left join SUPERCASH s2 on s1.shopindex = s2.shopindex and s2.cashnumber = :v_cash2 and s1.sckind = s2.sckind and s1.id = s2.id
                 where s1.shopindex = :v_shopindex and s1.cashnumber = :v_cash1 and s1.sckind = 1 and s2.shopindex is null)) then begin
      ret = 'F'; suspend; exit;
    end
    --       
    if (exists(select 1
                 from SUPERCASH s1
                 left join SUPERCASH s2 on s1.shopindex = s2.shopindex and s2.cashnumber = :v_cash1 and s1.sckind = s2.sckind and s1.id = s2.id
                 where s1.shopindex = :v_shopindex and s1.cashnumber = :v_cash2 and s1.sckind = 1 and s2.shopindex is null)) then begin
      ret = 'F'; suspend; exit;
    end
  end
  ret = 'T'; suspend;
end^

create or alter procedure IMPORT_DEVICE (
    DOCHEAD T_DOC,
    PLACEINDEX T_FID,
    ISITERSECT T_CHAR,
    ISPACK T_CHAR,
    ISSIZE T_CHAR,
    KIND_REWRITE T_INT_VALUE,
    ADD_ORDER T_INT_VALUE,
    SAVE_PRICE T_INT_VALUE,
    IS_ZERO T_INT_VALUE)
AS
declare variable articul t_articul_null;
declare variable quantity double precision;
declare variable packquantity double precision;
declare variable pack integer;
declare variable barcode t_barcode_null;
declare variable isrewrite3 integer;
declare variable old_articul t_articul_null;
declare variable rz integer;
declare variable pricerub double precision;
declare variable pricecur double precision;
declare variable pricerub_1 double precision;
declare variable pricecur_1 double precision;
declare variable v_dockind integer;
declare variable v_opertype integer;
declare variable v_shopindex integer;
declare variable v_filialindex integer;
declare variable v_pricekind integer;
declare variable v_r integer;
declare variable v_doc_filialindex2 integer;
declare variable v_placeindex integer;
declare variable v_is_kit smallint;
begin
  /* kind_rewrite -
     0 -       
     1 -       
     2 -    ,   
     3 -    ,   
     4 -  
     5 -   ,    

     add_order -    
     0 -  
     1 -    
     2 -    ,      , ..     
  */

  select h.shopindex, h.dockind, o.opertype, f.filial, h.client2_index
    from DOCHEAD h
    left join OPERATIONS o on o.id_operation = h.operation
    left join GET_FILIAL_FROM_DOC(h.id_dochead) f on 1=1
    where h.id_dochead = :dochead
  into :v_shopindex, :v_dockind, :v_opertype, :v_filialindex, :v_placeindex;

  --       
  if (kind_rewrite = 0) then delete from DOCSPEC where id_dochead = :dochead;

  if (kind_rewrite = 2 and is_zero = 1) then begin
    update DOCSPECEXT set pack_quantity = 0 where dochead = :dochead;
    update DOCSPEC set quantity = 0 where id_dochead = :dochead;
  end

  old_articul = '';
  for select articul, barcode, pack, rz, sum(quantity), sum(packquantity)
    from IMPORT_DEVICE_FETCH(:isitersect, :placeindex, :add_order, :v_dockind)
    where :kind_rewrite <> 5 or (articul in (select articul from DOCSPEC where id_dochead = :dochead))
    group by readnum, articul, barcode, pack, rz
    order by readnum, articul
    into :articul, :barcode, :pack, :rz, :quantity, :packquantity
  do begin
    if (exists(select 1
                 from CARDSCLA csc
                 inner join CARDTYPES cts on cts.id_cardtype = csc.cardtype and cts.cardkind = 6
               where csc.articul = :articul))
      then v_is_kit = 1; else v_is_kit = 0; -- -  
    for select :articul, :barcode, :pack, :rz, :quantity, :packquantity
          from rdb$database
          where :v_is_kit = 0
        union all
        select cg.subarticul, cg.outquant_out, cc.barcode, -1, -1, 0
          from rdb$database
          left join COMPLECT_GETCARDS2(:articul, :quantity, current_timestamp) cg on 1=1
          inner join CARDSCLA cc on cc.articul = cg.subarticul
          where :v_is_kit = 1
      into :articul, :barcode, :pack, :rz, :quantity, :packquantity
    do begin
      pricerub = 0; pricecur = 0; pricerub_1 = 0; pricecur_1 = 0;
      if (articul <> old_articul) then begin
        IsRewrite3 = 0;
        if ((kind_rewrite = 1 or kind_rewrite = 2 or kind_rewrite = 5) and save_price = 1) then begin
          select pricerub, pricecur, pricerub_1, pricecur_1
            from DOCSPEC where id_dochead = :dochead and articul = :articul
          into :pricerub, :pricecur, :pricerub_1, :pricecur_1;
        end
        if (kind_rewrite = 2)
          then delete from DOCSPEC where id_dochead = :dochead and articul = :articul;
        old_articul = articul;
      end

      if (pack < 0 or IsPack = 'F')
        then select mesuriment from CARDSCLA where articul = :articul into :pack;

      if (rz < 0 or IsSize = 'F') then rz = 0;

      if (pricerub = 0 and pricecur = 0) then begin
        --     spec_add_articul
        v_r = 0; --   v_r     
        if (v_dockind = 41) then v_r = -1; else --   
        if (v_dockind in (20,21,9,5)) then v_r = 1; else begin --  ,    
          if (v_dockind = 0 and v_opertype <> 1 or v_dockind in (16,51)) then v_r = 1;
          if (v_r = 1)
            then if (exists (select 1 from CONFIG where paramname = 'InputPriceKind' and numparam = 1))
                   then v_r = 2; --  -   
          if (v_dockind = 2) then begin
            if (exists (select 1 from CONFIG where paramname='MovePriceKind' and boolparam = 'T'))
              then v_r = 1; -- -   
              else v_r = 0; -- - 
          end
        end

        if (v_r = 0) then begin
          select pricekind from PRICE_SERVICE
            where filialindex = :v_filialindex and kind = 0 --   
          into :v_pricekind;
        end else
        if (v_r = 1) then begin
          select pricekind from PRICE_SERVICE
            where filialindex=:v_filialindex and kind = 2 --    
          into :v_pricekind;
        end else
        if (v_r = 2) then begin
          select id_pricekind from GET_PRICELIST_LAST_CONTRACT(:v_shopindex, :v_filialindex)
            into :v_pricekind; --    
        end else v_pricekind = -1; --    

        if (v_pricekind > -1)
          then select price_rub, price_cur from GET_PRICE2(:articul, :v_pricekind) into :pricerub, :pricecur;
      end

      if (pricerub_1 = 0 and pricecur_1 = 0) then begin
        if (v_dockind = 2) then begin
          select filial from GET_FILIAL_FROM_PLACE(:v_placeindex) into :v_doc_filialindex2;
          select p.price_rub, p.price_cur
            from PRICEKIND k
            left join GET_PRICE2(:articul, k.id_pricekind) p on 1 = 1
            where k.shopindex_pricekind = :v_shopindex and k.filialindex_pricekind = :v_doc_filialindex2 and k.kind = 0
          into :pricerub_1, :pricecur_1;
        end else begin
          select p.price_rub, p.price_cur
            from PRICEKIND k
            left join GET_PRICE2(:articul, k.id_pricekind) p on 1=1
            where k.shopindex_pricekind = :v_shopindex and k.filialindex_pricekind = :v_filialindex and k.kind = 0
          into :pricerub_1, :pricecur_1;
        end
      end

      if (exists (select 1 from DOCSPEC where articul = :articul and id_dochead = :dochead)) then begin
        if (kind_rewrite <> 3 or IsRewrite3 = 1) then begin
          execute procedure IMPORT_UPDATE_DOCSPEC(:dochead, :articul, :quantity, :barcode,:pack, :rz,
                                                  :packquantity, :pricerub, :pricecur, :pricerub_1, :pricecur_1,
                                                  '', :kind_rewrite);
        end
      end else begin
        if (kind_rewrite <> 4) then begin
          insert into DOCSPEC(id_dochead, articul, quantity, pricerub, pricecur, pricerub_1, pricecur_1, mesuriment, barcode, rz)
            values(:dochead, :articul, :quantity, :pricerub, :pricecur, :pricerub_1, :pricecur_1, :pack, :barcode, :rz);
          if (kind_rewrite = 3) then IsRewrite3 = 1;
        end
      end
    end
  end
end^

create or alter procedure XCASH_LOAD_PLUCASH (
    V_DATE T_DATE_NULL,
    V_FULL_LOAD T_CHAR,
    V_CASH T_FID,
    V_SESSION T_FID)
returns (
    ARTICUL T_ARTICUL_NULL,
    NAME T_FULL_NAME_NULL,
    MESURIMENT T_STR10_NULL,
    MESPRESISION T_NUM_VALUE,
    ADD1 T_STR20,
    ADD2 T_STR20,
    ADD3 T_STR20,
    ADDNUM1 T_NUM_VALUE,
    ADDNUM2 T_NUM_VALUE,
    ADDNUM3 T_NUM_VALUE,
    SCALE T_STR10_NULL,
    GROOP1 T_FID,
    GROOP2 T_FID,
    GROOP3 T_FID,
    GROOP4 T_FID,
    GROOP5 T_FID,
    PRICERUB T_MONEY_NULL,
    PRICECUR T_MONEY_NULL,
    CLIENTINDEX T_FID,
    COMMENTARY T_FULL_NAME_NULL,
    DELETED T_INT_VALUE,
    MODDATE T_DATE_NULL,
    MODTIME T_INT_VALUE,
    MODPERSONINDEX T_FID,
    TAXHEAD T_FID,
    ID T_FID,
    CASHQUANT T_INT_VALUE,
    CLASSIF T_FID,
    CASHPRICE T_FID,
    IS_ALCO T_INT_VALUE,
    VID_PROD T_NAME_NULL,
    VOLUME T_NUM_VALUE,
    SPIRT_PROC T_NUM_VALUE,
    PIO T_INT_VALUE)
AS
declare variable v_shopindex integer;
declare variable v_filialindex integer;
declare variable v_priceindex integer;
declare variable v_classif integer;
declare variable v_accept char;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
--declare variable v_bar_quantity double precision;
declare variable v_bar_pricerub double precision;
declare variable v_bar_pricecur double precision;
declare variable v_bar_discount double precision;
declare variable v_bar_roundrub double precision;
declare variable v_bar_roundcur double precision;
declare variable v_bar_postfix integer;
declare variable v_bar_pack integer;
declare variable v_articul t_articul_null;
declare variable v_taxfrom integer;
declare variable v_placeindex integer;
declare variable x_placeindex integer;
declare variable v_use_ost_pack integer;
declare variable v_use_cashplace integer;
declare variable v_fix_cashplace integer;
declare variable v_only_rzscale integer;
declare variable v_use_cardcashplace integer;
declare variable v_continue integer;
declare variable v_ret integer;
declare variable v_mesuriment integer;
declare variable v_shortname t_name_null;
declare variable v_use_shortname integer;
declare variable v_save_price integer;
declare variable v_s t_str_value;
declare variable v_rzscale integer;
declare variable v_print_groups integer;
declare variable v_use_alko integer;
declare variable v_alco_unmark smallint;
declare variable v_cash_kind integer;
declare variable v_wo_nds integer;
declare variable v_taxhead_wo_nds integer;
begin
  setpriority(-15);
  v_date = v_date; v_full_load = v_full_load;
  execute procedure PRN_FILL_CLASSIF(-1);

  select v_num from PARAMS where session = :v_session and class = 'Common' and name = 'ShopIndex' into :v_shopindex;

  if (exists(select 1 from CONFIG where paramname = 'UseOstPack' and boolparam = 'T'))
    then v_use_ost_pack = 1; else v_use_ost_pack = 0;
  if (exists(select 1 from CONFIG where paramname = 'CashLoadUsePlace' and boolparam = 'T'))
    then v_use_cashplace = 1; else v_use_cashplace = 0;
  if (exists(select 1 from CONFIG where paramname = 'UseCardCashPlace' and boolparam = 'T'))
    then v_use_cardcashplace = 1; else v_use_cardcashplace = 0;
  if (exists(select 1 from CONFIG where paramname = 'CashLoadShortName' and boolparam = 'T'))
    then v_use_shortname = 1; else v_use_shortname = 0;
  if (exists(select 1 from CONFIG where paramname = 'CashLoadFixPlace' and boolparam = 'T'))
    then v_fix_cashplace = 1; else v_fix_cashplace = 0;
  if (exists(select 1 from CONFIG where paramname = 'CashOnlyRzScale' and boolparam = 'T'))
    then v_only_rzscale = 1; else v_only_rzscale = 0;
  if (exists(select 1 from CONFIG where paramname = 'CashLoadSavePrice' and boolparam = 'T'))
    then v_save_price = 1; else v_save_price = 0;
  if (exists(select 1 from CONFIG where paramname = 'UseCashPrintGroups' and boolparam = 'T'))
    then v_print_groups = 1; else v_print_groups = 0;
  if (exists(select 1 from CONFIG where paramname = 'UseAlko' and boolparam = 'T'))
    then v_use_alko = 1; else v_use_alko = 0;
  select numparam from CONFIG where paramname = 'CashCloseTax' into :v_taxfrom;

  --  v_filialindex  x_placeindex -      
  x_placeindex = null;
  select filialindex, placeindex, cashkind, wo_nds from CASH_LIST
    where shopindex = :v_shopindex and id_cash_list = :v_cash
  into :v_filialindex, :x_placeindex, :v_cash_kind, :v_wo_nds;
  if (x_placeindex is null) then begin --       
    x_placeindex = -1; v_filialindex = -1;
  end

  --    " "
  if (v_wo_nds = 1)
    then select coalesce(min(id_taxhead), -1) from TAXHEAD
           where upper(name_taxhead collate PXW_CYRL) = ' '
           rows 1
         into :v_taxhead_wo_nds;
    else v_taxhead_wo_nds = -1;

  select priceindex from XCASH_GET_LOAD_PRICE(:v_cash, :v_shopindex, :v_filialindex) into :v_priceindex;

  deleted = 1;
  for select t.articul, t.id, t.place,
             cs.classif, cs.name, cs.shortname, cs.mesuriment,
             substring(cs.sertif from 1 for 20), substring(cs.sertif from 21 for 20), substring(cs.sertif from 41 for 20),
--           substring(cs.add_param1 from 1 for 20), substring(cs.add_param2 from 1 for 20), substring(cs.add_param3 from 1 for 20),
             cs.is_accept, cs.is_cashquant, cs.is_cashprice, cs.rzscale, cs.classif, iif(cs.is_alco = 'T' and :v_use_alko = 1, 1, 0), cs.netto,
             coalesce(pio.frontol_code, 1)
    from TMP_LOAD_CARDSCLA t
    left join CARDSCLA cs on cs.articul = t.articul
    left join CARDTYPES ct on ct.id_cardtype = cs.cardtype
    left join PAYMENT_ITEM_OBJECT pio on pio.id = ct.payment_item_object
    where t.filialindex = :v_filialindex
    into :articul, :id, :v_placeindex,
         :v_classif, :name, :v_shortname, :v_mesuriment,
         :add1, :add2, :add3,
         :v_accept, :cashquant, :cashprice, :v_rzscale, :classif, :is_alco, :volume,
         :pio
  do begin

    clientindex = v_placeindex;

    v_s = '';
    if (v_only_rzscale = 0) then begin
      if (exists(select 1 from CARDASRT where articul = :articul and is_use = 1))
        then v_s = id;
    end else begin
      if (v_rzscale is not null and v_rzscale > -1 and
          exists(select 1 from RZSCALE where id = :v_rzscale))
        then v_s = v_rzscale;
    end
    scale = 'NOSIZE';
    if (v_s <> '') then if (char_length(v_s) < 11) then scale = v_s;
    if (v_accept = 'T') then deleted = 1; else deleted = 0;
    select substring(name_mesuriment from 1 for 10), power(10, precision_mesurim)
      from MESURIMENT where id_mesuriment = :v_mesuriment
    into :mesuriment, :mespresision;
    groop1 = null; groop2 = null; groop3 = null; groop4 = null; groop5 = null;
    select group1, group2, group3, group4, group5 from PRN_CLASSIF
      where id = :v_classif
    into :groop1, :groop2, :groop3, :groop4, :groop5;
    if (groop1 is null) then exception E_ERR_PRN_CLASSIF;

    --     
    if (v_fix_cashplace = 1) then begin       --        
      clientindex = x_placeindex;             -- -     
    end else begin
      if (v_print_groups = 1) then begin
        --   -   
        --           
        select pcpg.place
          from CARD_GET_PRINT_GROUP(:articul, :v_filialindex) cpg
          left join PLACE_CASH_PRINT_GROUPS pcpg on pcpg.filial = :v_filialindex and pcpg.cash_print_group = cpg.id
        into :clientindex;
      end else begin
        --   -    
        --       ,        
        if (clientindex = -1) then clientindex = null;
        if (clientindex is not null and
            not exists(select 1 from GET_FILIAL_FROM_PLACE(:clientindex) where filial = :v_filialindex)) then begin
          --                 8    
          --              =  
          v_ret=null; --          
          select id from SUPERPLACE where placeindex = :clientindex and spkind = 8 and is_used = 'T' and sp_is_used = 'T'
            rows 1 into :v_ret; --    (        )
          clientindex = null; --        ,    
          if (v_ret is not null) then --        
            select s.placeindex
              from SUPERPLACE s
              left join GET_FILIAL_FROM_PLACE(s.placeindex) f on 1=1
              where s.id = :v_ret and s.is_used = 'T' and f.filial = :v_filialindex
            rows 1 into :clientindex; --    (        )
        end
      end
    end

    --     ( )
    if (v_use_cardcashplace = 1 and          --       
        v_use_cashplace = 1) then begin      --        
      v_continue = 0;
      if (clientindex is not null and
          exists(select 1 from CARDCASHPLACE where articul = :articul and placeindex = :clientindex and is_used = 1))
        then v_continue = 1;
    end else v_continue = 1;

    if (v_continue = 1) then begin
      if (clientindex is distinct from v_placeindex) then begin
        v_placeindex = coalesce(clientindex, -1);
        update TMP_LOAD_CARDSCLA set place = :v_placeindex
          where filialindex = :v_filialindex and articul = :articul;
      end

      -- 
      if (v_use_shortname = 1 and char_length(v_shortname) > 0) then name = v_shortname;

      --    
      taxhead = -1;
      if (v_taxhead_wo_nds > -1) then begin
        taxhead = v_taxhead_wo_nds;
      end else begin
        if (v_taxfrom = 0)
          then select taxhead from CLASSTAX
                  where classif = :v_classif and shopindex = :v_shopindex and operkind = 0
               into :taxhead;
          else select taxhead from CARDTAX
                  where articul = :articul and oper_kind = 0
               into :taxhead;
      end
      --    
      select tax1 from TAXSPEC where taxhead = :taxhead and tax_kind = 0 into :addnum2;
      select tax1 from TAXSPEC where taxhead = :taxhead and tax_kind = 1 into :addnum3;


      select price_rub, price_cur from GET_PRICE2(:articul, :v_priceindex)
        into :v_pricerub, :v_pricecur;

      pricerub = v_pricerub; pricecur = v_pricecur;

      if (v_save_price = 1)
        then execute procedure CASH_SAVE_PRICE(:articul, :v_filialindex, :pricerub);

      --  clientindex (  )     
      --        clientindex=null     
      --     clientindex   x_placeindex
      if (clientindex is null) then clientindex = x_placeindex;
      addnum1 = 0; -- addnum1               
      if (v_use_ost_pack = 1)
        then select quantity from OSTATOK_PACK
               where articul = :articul and pack = :v_mesuriment and place_index = :clientindex
             into :addnum1;
        else select quantity from OSTATOK_SHORT
               where articul = :articul and place_index = :clientindex
             into :addnum1;

      if (addnum1 is null) then addnum1 = 0;
      addnum1 = round(addnum1, 3);

      --  
      vid_prod = ''; spirt_proc = 0; v_alco_unmark = 0;
      if (is_alco = 1) then begin
        --  
        select vp.kod, vp.unmark
          from CARDPARAMS cp
          left join VID_PROD vp on vp.id = cp.paramvalue
          where :articul = cp.articul and cp.paramtype = 7
        into :vid_prod, :v_alco_unmark;
        if (v_alco_unmark = 1)
          then if (:v_cash_kind in (2,7)) --     SET Retail 5     ,      
                 then is_alco = 0;
                 else is_alco = 2;
        --   
        select cp.paramvalue from CARDPARAMS cp where :articul = cp.articul and cp.paramtype = 6 into :spirt_proc;
      end else volume = 0; --   ,    

      suspend;

      v_articul = articul;
      for select --b.quantity,
                 b.price_rub, b.price_cur, b.discount,
                 b.round_to_rub, b.round_to_cur, b.postfix, b.pack
        from BAR bc
        left join GET_BARCODE_PARAMS(bc.barcode,: v_filialindex) b on 1=1
        where bc.articul = :v_articul and
              (b.pack is not null or b.postfix <> -1)
        into --:v_bar_quantity,
             :v_bar_pricerub, :v_bar_pricecur,
             :v_bar_discount, :v_bar_roundrub, :v_bar_roundcur,
             :v_bar_postfix, :v_bar_pack
      do begin
        v_s = v_articul || '@' || v_bar_postfix;
        if (v_bar_pack is not null) then v_s = v_s || '@@' || v_bar_pack;
        if (char_length(v_s) < 31) then begin
          articul = v_s; pricerub = v_pricerub; pricecur = v_pricecur;
          if (v_bar_discount <> 0) then begin
            pricerub = null; pricecur = null;
            select r_value from ROUND_TO_NUM(:v_pricerub * (100 - :v_bar_discount) / 100, :v_bar_roundrub) into :pricerub;
            select r_value from ROUND_TO_NUM(:v_pricecur * (100 - :v_bar_discount) / 100, :v_bar_roundcur) into :pricecur;
            if (pricerub is null) then pricerub = 0; if (pricecur is null) then pricecur = 0;
          end else
            if (v_bar_pricerub <> 0 or v_bar_pricecur <> 0) then begin
              pricerub = v_bar_pricerub; pricecur = v_bar_pricecur;
            end
          addnum1 = 0;
          if (v_bar_pack is not null and v_use_ost_pack = 1) then begin
            select quantity from OSTATOK_PACK
              where articul = :v_articul and pack = :v_bar_pack and place_index = :clientindex
            into :addnum1;
            if (addnum1 is null) then addnum1 = 0;
            addnum1 = round(addnum1, 3);
          end
          suspend;
        end
      end
    end else -- if continue
      delete from TMP_LOAD_CARDSCLA where filialindex = :v_filialindex and articul = :articul;
  end
end^

create or alter procedure XCASH_GET_TAXHEAD (
    V_SHOPINDEX T_FID,
    V_CASH T_FID,
    V_OPERATION T_FID,
    V_ARTICUL T_ARTICUL_NULL)
returns (
    TAXHEAD T_FID)
AS
declare variable v_operkind integer;
declare variable v_wo_nds integer;
declare variable v_taxhead_wo_nds integer;
begin
  --    
  select wo_nds from CASH_LIST
    where shopindex = :v_shopindex and id_cash_list = :v_cash
  into :v_wo_nds;

  if (v_wo_nds = 1) then begin --    " "
    select coalesce(min(id_taxhead), -1) from TAXHEAD
       where upper(name_taxhead collate PXW_CYRL) = ' '
       rows 1
    into :taxhead;
  end else begin
    select operkind from OPERATIONS where id_operation = :v_operation into :v_operkind;
    if (exists (select 1 from CONFIG where paramname = 'CashCloseTax' and numparam = 0))
      then select taxhead
             from CARDSCLA cs
             left join CLASSTAX clt on clt.classif = cs.classif and
                                       clt.shopindex = :v_shopindex and
                                       clt.operkind = :v_operkind
             where cs.articul = :v_articul
           into :taxhead;
      else select taxhead from CARDTAX
             where articul = :v_articul and oper_kind = :v_operkind
           into :taxhead;
  end
  suspend;
end^

create or alter procedure KM_DOWNLOAD (
    V_SHOPINDEX T_FID,
    V_CASHNUMBER T_FID,
    V_ZNUMBER T_FID,
    SESSION T_FID)
returns (
    NODATA T_INT_VALUE,
    ERR T_INT_VALUE)
AS
declare variable v_checknumber integer;
declare variable v_id integer;
declare variable v_sell_date date;
declare variable v_sell_time date;
declare variable v_articul t_articul_null;
declare variable v_cardsize t_str_value;
declare variable v_quantity double precision;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
declare variable v_totalrub double precision;
declare variable v_totalcur double precision;
declare variable v_department integer;
declare variable v_casher integer;
declare variable v_usingindex integer;
declare variable v_replace integer;
declare variable v_operation integer;
declare variable v_credcardindex integer;
declare variable v_disccliindex integer;
declare variable v_subtaxhead integer;
declare variable v_taxhead integer;
declare variable v_pack integer;
declare variable v_asrt integer;
declare variable v_collectkind integer;
declare variable v_compl_id integer;
declare variable d_collectkind integer;
declare variable v_subarticul t_articul_null;
declare variable v_subquantity double precision;
declare variable v_subpricerub double precision;
declare variable v_subpricecur double precision;
declare variable v_avg_pricerub double precision;
declare variable v_avg_pricecur double precision;
declare variable v_compldate date;
-- shopindex  filialindex   v_usingindex
declare variable v_si integer;
declare variable v_fi integer;
declare variable d_date date;
declare variable c_sal double precision;
declare variable c_ret double precision;
declare variable c_res double precision;
declare variable c_date date;
declare variable m_date date;
declare variable k_sal double precision;
declare variable k_ret double precision;
begin
  --    ..        km_
  --     

  NoData = 0; err = 0;

  c_date = null;
  select date_begin, sale, ret, result
    from KM_CURRESTS
    where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber and
          is_active = 0 --      
  into :c_date, :c_sal, :c_ret, :c_res;

  if (c_date is null) then begin
    NoData = 1; err = 2; suspend; exit; --   ..    
  end
  c_date = extractdate(c_date); m_date = c_date;
  if (exists(select 1 from CURRESTS
              where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber)) then begin
    /*         ,   
        (         )
              
            
         1)        
         2)        ,     
         3)     km_-,     
    */
    NoData = 1; err = 3; suspend; exit; --   ..    
  end

  --            (TfmDownLoadCash.OneCashDownLoad)

  insert into CURRESTS(shopindex, cashnumber, znumber, date_begin, sale, ret, storno, stornret, result, session)
    values(:v_shopindex, :v_cashnumber, :v_znumber, :c_date, :c_sal, :c_ret, 0, 0, :c_res, :session);

  insert into CASHDCRD(shopindex, cashnumber, znumber, checknumber, cardtype, cardnumber, discountrub, discountcur)
    select shopindex, cashnumber, znumber, checknumber, cardtype, cardnumber, discountrub, discountcur
      from KM_CASHDCRD
    where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber;

  --  
  d_collectkind = null; --        (  )
  d_date = StrToDateFmt('dd.mm.yyyy', '01.01.1900'); --   -     StrToDateFmt  Delphi (    )

  k_sal = 0; k_ret = 0;
  for select checknumber, id, sell_date, sell_time,
             articul, quantity, pricerub, pricecur, totalrub, totalcur,
             department, casher, placeindex, replace, operation, credcardindex, disccliindex,
             taxhead, pack, asrt
    from KM_CASHSAIL
    where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber
    into :v_checknumber, :v_id, :v_sell_date, :v_sell_time,
         :v_articul, :v_quantity, :v_pricerub, :v_pricecur, :v_totalrub, :v_totalcur,
         :v_department, :v_casher, :v_usingindex, :v_replace, :v_operation, :v_credcardindex, :v_disccliindex,
         :v_taxhead, :v_pack, :v_asrt
  do begin
    --    z-
    if (v_replace = 1) then k_sal = k_sal + v_totalrub; else k_ret = k_ret + v_totalrub;
    if (v_sell_date > m_date) then m_date = v_sell_date;

    --     .   xcash_download_cashsail
    v_collectkind = -1; v_compl_id = null;
    if (exists(select 1 from CARDCOMPL_HEADER where articul = :v_articul)) then begin
      --     
      select compl_id
        from CARDCOMPL_HEADER where articul = :v_articul and compl_date <= :v_sell_date
        order by articul desc, compl_date desc --  -     
        rows 1
      into :v_compl_id;
      if (v_compl_id is not null) then begin
        if (exists (select 1 from CARDCOMPL where compl_id = :v_compl_id)) then begin -- ,    " "
          v_collectkind = null;
          select collectkind from CARDCOLLECT where articul = :v_articul and place_index = :v_usingindex into :v_collectkind;
          if (v_collectkind is null) then begin
            v_collectkind = null;
            select collect_kind from CLIENTS where id_clients = :v_usingindex into :v_collectkind;
            if (v_collectkind is null) then begin
              if (d_collectkind is null) then select numparam from CONFIG where paramname = 'CollectKindDefault' into :d_collectkind;
              v_collectkind = d_collectkind;
            end
            if (not exists(select 1 from COLLECTKIND where id = :v_collectkind)) then v_collectkind = 0;
          end
        end
      end
    end

    v_cardsize = '^' || v_asrt;

    --       
    --         
    select filial, shopindex from GET_FILIAL_FROM_PLACE(:v_usingindex) into :v_fi, :v_si;
    if (not exists(select 1 from CONFIG where paramname = 'CashLockByFilial' and boolparam = 'T'))
      then v_fi = -1;
    select session from XCASH_SESSION_GET(:v_si, :v_fi) into :session;

    if (v_si <> v_shopindex) then exception e_cash_err_shopindex;

    if (v_department = -1) then v_department = 0; --    -1  < >     < >  0 (       )

    insert into CASHSAIL(shopindex, cashnumber, znumber, checknumber, id, sell_date, sell_time,
                         cardarticul, cardsize, quantity, pricerub, pricecur, totalrub, totalcur,
                         department, casher, usingindex, replace, operation, credcardindex, disccliindex,
                         taxhead, pack, collect_kind, rz, session, linked)
      values(:v_shopindex, :v_cashnumber, :v_znumber, :v_checknumber, :v_id, :v_sell_date, :v_sell_time,
             :v_articul, :v_cardsize, :v_quantity, :v_pricerub, :v_pricecur, :v_totalrub, :v_totalcur,
             :v_department, :v_casher, :v_usingindex, :v_replace, :v_operation, :v_credcardindex, :v_disccliindex,
             :v_taxhead, :v_pack, :v_collectkind, :v_asrt, :session, 0);

    --   xcash_download_cashsail
    if (v_collectkind = 1) then begin
      v_avg_pricerub = 0; v_avg_pricecur = 0;
      if (v_quantity <> 0) then begin
        v_avg_pricerub = v_totalrub / v_quantity;
        v_avg_pricecur = v_totalcur / v_quantity;
      end
      for select articul, sum(quantity), sum(quantity * pricerub), sum(quantity * pricecur)
        from COMPLECT_GETCARDS(:v_si, :v_fi, :v_usingindex, :v_articul,
                               :v_avg_pricerub, :v_avg_pricecur, 'F', :v_sell_date)
        group by articul
        into :v_subarticul, :v_subquantity, :v_subpricerub, :v_subpricecur
      do begin
        --    
        v_collectkind = -1; v_compldate = d_date;
        if (exists (select 1 from CARDCOMPL_HEADER where articul = :v_subarticul)) then begin
          select max(compl_date)
            from CARDCOMPL_HEADER where articul = :v_subarticul and compl_date <= :v_sell_date
          into :v_compldate;
          if (exists (select 1 from CARDCOMPL_HEADER where articul = :v_subarticul and
                                                     compl_date = :v_compldate)) then begin
            select collectkind
              from CARDCOLLECT where articul = :v_subarticul and place_index = :v_usingindex
            into :v_collectkind;
            if (v_collectkind is null or v_collectkind = -1) then begin
              select collect_kind from CLIENTS where id_clients = :v_usingindex into :v_collectkind;
              if (v_collectkind is null or v_collectkind = -1)
                then select numparam from CONFIG where paramname = 'CollectKindDefault' into :v_collectkind;
              if (not exists (select 1 from COLLECTKIND where id = :v_collectkind)) then v_collectkind = 0;
            end
          end
        end

        select mesuriment from CARDSCLA where articul = :v_subarticul into :v_pack;
        select taxhead from XCASH_GET_TAXHEAD(:v_shopindex, :v_cashnumber, :v_operation, :v_subarticul) into :v_subtaxhead;
        if (v_subquantity <> 0) then begin
          v_subpricerub = v_subpricerub / v_subquantity;
          v_subpricecur = v_subpricecur / v_subquantity;
        end else begin
          v_subpricerub = 0;
          v_subpricecur = 0;
        end
        insert into CASHSAIL_COMPL (shopindex, cashnumber, znumber, checknumber, id,
                                    subarticul, quantity, pricerub, pricecur,
                                    cardarticul, taxhead, mesuriment, collect_kind, rz)
          values (:v_shopindex, :v_cashnumber, :v_znumber, :v_checknumber, :v_id,
                  :v_subarticul, :v_quantity * :v_subquantity,
                  :v_subpricerub, :v_subpricecur,
                  :v_articul, :v_subtaxhead, :v_pack, :v_collectkind, 0); -- rz  =0 ..     
      end
    end

  end

  insert into CASHDISC(shopindex, cashnumber, znumber, checknumber, id, discountindex, discountproc, discountrub, discountcur, discount_id)
    select shopindex, cashnumber, znumber, checknumber, id, discountindex, discountproc, discountrub, discountcur, discount_id
      from KM_CASHDISC
    where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber;

  insert into CASHPAY(shopindex, cashnumber, znumber, checknumber, payment, cardnumb,
                      payedmoney, doscountmoney, payedrub, payedcur,
                      discountrub, discountcur, discclirub, discclicur)
    select shopindex, cashnumber, znumber, checknumber, payment, cardnumb,
           0, 0, payedrub, payedcur,
           0, 0, 0, 0
      from KM_CASHPAY
    where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber;

  if (cmp_dbl_e(k_sal, c_sal) <> 0 or
      cmp_dbl_e(k_ret, c_ret) <> 0 or
      cmp_dbl_e(k_sal - k_ret, c_res) <> 0) then begin
    update CURRESTS set sale = :k_sal, ret = :k_ret, result = :k_sal - :k_ret, date_begin = :m_date
      where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber;
    err = 1;
  end else
  if (m_date <> c_date) then begin
    -- currests.date_begin           
    -- ..          
    update CURRESTS set date_begin = :m_date
      where shopindex = :v_shopindex and cashnumber = :v_cashnumber and znumber = :v_znumber;
  end

  --  km_   ''   xcash_download_end,    km_-      
  -- ..       (, )

  suspend;
end^

create or alter procedure XCASH_DOWNLOAD_CASHSAIL (
    V_SHOPINDEX T_FID,
    V_CASHNUMBER T_FID,
    V_ZNUMBER T_FID,
    V_CHECKNUMBER T_FID,
    V_ID T_FID,
    V_SELL_DATE T_DATE_NULL,
    V_SELL_TIME T_INT_VALUE,
    V_ARTICUL T_STR_VALUE,
    V_CARDSIZE T_STR_VALUE,
    V_QUANTITY T_QUANTITY_NULL,
    V_PRICERUB T_MONEY_NULL,
    V_PRICECUR T_MONEY_NULL,
    V_TOTALRUB T_MONEY_NULL,
    V_TOTALCUR T_MONEY_NULL,
    V_DEPARTMENT T_FID,
    V_CASHER T_FID,
    V_USINGINDEX T_FID,
    V_REPLACE T_INT_VALUE,
    V_OPERATION T_FID,
    V_CREDCARDINDEX T_INT_VALUE,
    V_DISCCLIINDEX T_INT_VALUE,
    V_LINKED T_INT_VALUE,
    V_ASRT_NAME T_FULL_NAME_NULL,
    SESSION T_FID)
returns (
    SUCCESS T_INT_VALUE)
AS
declare variable v_taxhead integer;
declare variable v_subtaxhead integer;
declare variable v_real_time date;
declare variable v_hour integer;
declare variable v_minute integer;
declare variable v_pack integer;
declare variable v_rz integer;
declare variable v_pos integer;
declare variable v_len integer;
declare variable v_collectkind integer;
declare variable v_subarticul t_articul_null;
declare variable v_subquantity double precision;
declare variable v_subpricerub double precision;
declare variable v_subpricecur double precision;
declare variable v_avg_pricerub double precision;
declare variable v_avg_pricecur double precision;
declare variable v_full_minute integer;
declare variable v_trunc_minute integer;
declare variable v_certif integer;
/* shopindex  filialindex   v_usingindex */
declare variable v_si integer;
declare variable v_fi integer;
declare variable v_i integer;
begin

  success = 0;
  if (exists(select 1 from CURRESTS
               where shopindex = :v_shopindex and
                     cashnumber = :v_cashnumber and
                     znumber = :v_znumber and
                     session = :session)) then begin

    --  
    v_hour = div(v_sell_time, 100);
    v_minute = mod(v_sell_time, 100);
    v_full_minute = v_hour * 60 + v_minute;
    select coalesce(numparam, 0) from CONFIG where paramname = 'CashMinuteTrunc' into :v_trunc_minute;
    if (v_trunc_minute > 0 and v_full_minute <= v_trunc_minute) then begin
      v_sell_date = v_sell_date-1;
      v_real_time = '30.12.1899 23:59';
    end else begin
      v_real_time = '30.12.1899 ' || v_hour || ':' || v_minute;
    end

    --       
    --         
    select filial, shopindex from GET_FILIAL_FROM_PLACE(:v_usingindex) into :v_fi, :v_si;
    if (v_si <> v_shopindex) then exception E_CASH_ERR_SHOPINDEX;
    if (not exists(select 1 from CONFIG where paramname = 'CashLockByFilial' and boolparam = 'T'))
      then v_fi = -1;
    select session from XCASH_SESSION_GET(:v_si, :v_fi) into :session;

    --    
    v_pack = null;
    v_pos = position('@@' in v_articul);
    if (v_pos > 0) then begin
      v_len = char_length(v_articul);
      v_pack = substring(v_articul from v_pos + 2 for v_len - v_pos - 1);
      v_articul = substring(v_articul from 1 for v_pos - 1);
    end
    v_pos = position('@' in v_articul);
    if (v_pos > 0) then
      v_articul = substring(v_articul from 1 for v_pos - 1);

    --  
    v_pos = position('$' in v_articul);
    if (v_pos > 0) then begin
      v_len = char_length(v_articul);
      v_certif = substring(v_articul from v_pos + 1 for v_len - v_pos);
      v_articul = substring(v_articul from 1 for v_pos - 1);
    end

    --  v_articul -       -     
    v_i = null;
    select mesuriment from CARDSCLA where articul = :v_articul into :v_i;
    if (v_i is null) then begin --   
      v_articul = 'VOID';
      select m.id_mesuriment
        from CARDSCLA c left join MESURIMENT m on m.id_mesuriment = c.mesuriment
        where articul = :v_articul
      into :v_i;
      --         
      --          
      --         
      if (v_i is null) then exception E_DOCSPEC_ARTICUL;
      --         (   )
      --           'VOID'
    end else if (v_pack is null) then v_pack = v_i;


    --     -    
    v_rz = 0;
    if (v_asrt_name is not null) then begin
      select asrt
        from CARDASRT cs where cs.articul = :v_articul and
                         (upper(cs.name collate PXW_CYRL)) = upper(:v_asrt_name collate PXW_CYRL)
      into :v_rz;
    end else begin --   cardsize -
      --   (      )

      v_pos = position('^' in v_cardsize);
      if (v_pos > 0) then begin
        v_len = char_length(v_cardsize);
        v_rz = substring(v_cardsize from v_pos + 1 for v_len - v_pos);

        if (exists(select 1 from CONFIG where paramname = 'CashOnlyRzScale' and boolparam = 'T')) then begin
          --  v_rz  rz.id .. ,    

          --         
          --       (   )
          --     < >
          v_i = v_rz; v_rz = null;
          for select asrt from CARDASRTATTRIBSP
            where articul = :v_articul and attrib = 0 and attribsp = :v_i
            into :v_pos
          do if (v_rz is null) then v_rz = v_pos; else v_rz = 0;
          if (v_rz is null) then v_rz = 0;
        end
      end
    end

    --    
    if (v_quantity < 0) then v_quantity = -v_quantity;
    if (v_pricerub is null) then begin
      --      ,        
      select priceindex from XCASH_GET_LOAD_PRICE(:v_cashnumber, :v_si, :v_fi) into :v_i;
      select price_rub, price_cur from GET_PRICE2(:v_articul,:v_i) into :v_pricerub, :v_pricecur;
    end else begin
      if (v_pricerub < 0) then v_pricerub = -v_pricerub;
      if (v_pricecur < 0) then v_pricecur = -v_pricecur;
    end
    if (v_totalrub < 0) then v_totalrub = -v_totalrub;
    if (v_totalcur < 0) then v_totalcur = -v_totalcur;

    --    
    select coalesce(taxhead, -1) from XCASH_GET_TAXHEAD(:v_shopindex, :v_cashnumber, :v_operation, :v_articul) into :v_taxhead;

    --     
    v_collectkind = -1;
    if (exists (select 1
                  from CARDCOMPL_HEADER ch
                  inner join CARDCOMPL cc on cc.compl_id = ch.compl_id --     
                  where ch.articul = :v_articul and ch.compl_date <= :v_sell_date)) then begin
      select collectkind
        from CARDCOLLECT
        where articul = :v_articul and place_index = :v_usingindex
      into :v_collectkind;
      if (v_collectkind = -1) then begin
        select coalesce(collect_kind, -1) from CLIENTS where id_clients = :v_usingindex into :v_collectkind;
        if (v_collectkind = -1)
          then select numparam from CONFIG where paramname = 'CollectKindDefault' into :v_collectkind;
      end
      if (v_collectkind = -1) then v_collectkind = 0;
    end

    insert into CASHSAIL(session, shopindex, cashnumber, znumber,
                         checknumber, id,sell_date, sell_time,
                         cardarticul, cardsize, quantity, pricerub,
                         pricecur, totalrub, totalcur,department,
                         casher, usingindex, replace, operation,
                         credcardindex, disccliindex, linked, taxhead,
                         pack, collect_kind, rz, certificate)
      values (:session, :v_shopindex, :v_cashnumber, :v_znumber,
              :v_checknumber, :v_id, :v_sell_date, :v_real_time,
              :v_articul, :v_cardsize, :v_quantity, :v_pricerub,
              :v_pricecur, :v_totalrub, :v_totalcur, :v_department,
              :v_casher, :v_usingindex, :v_replace, :v_operation,
              :v_credcardindex, :v_disccliindex, :v_linked, :v_taxhead,
              :v_pack, :v_collectkind, :v_rz, :v_certif);

    --      
    if (v_credcardindex > 0 and
        not exists (select 1 from CASH_PAY_TYPE where id = :v_credcardindex))
      then insert into CASH_PAY_TYPE (id,name,comment)
             values (:v_credcardindex, '   (id=' || :v_credcardindex || ')', '');

    --  ,      -  
    if (v_collectkind = 1) then begin
      v_avg_pricerub = 0; v_avg_pricecur = 0;
      if (v_quantity <> 0) then begin
        v_avg_pricerub = v_totalrub / v_quantity;
        v_avg_pricecur = v_totalcur / v_quantity;
      end
      for select articul, sum(quantity), sum(quantity * pricerub), sum(quantity * pricecur)
        from COMPLECT_GETCARDS(:v_si, :v_fi, :v_usingindex, :v_articul,
                               :v_avg_pricerub, :v_avg_pricecur, 'F', :v_sell_date)
        group by articul
        into :v_subarticul, :v_subquantity, :v_subpricerub, :v_subpricecur
      do begin
        --    
        v_collectkind = -1;
        if (exists (select 1 from CARDCOMPL_HEADER where articul = :v_subarticul and compl_date <= :v_sell_date)) then begin
          select collectkind
            from CARDCOLLECT
            where articul = :v_subarticul and place_index = :v_usingindex
          into :v_collectkind;
          if (v_collectkind = -1) then begin
            select collect_kind from CLIENTS where id_clients = :v_usingindex into :v_collectkind;
            if (v_collectkind = -1)
              then select numparam from CONFIG where paramname = 'CollectKindDefault' into :v_collectkind;
          end
          if (v_collectkind = -1) then v_collectkind = 0;
        end

        select mesuriment from CARDSCLA where articul = :v_subarticul into :v_pack;
        select taxhead from XCASH_GET_TAXHEAD(:v_shopindex, :v_cashnumber, :v_operation, :v_subarticul) into :v_subtaxhead;
        if (v_subquantity <> 0) then begin
          v_subpricerub = v_subpricerub / v_subquantity;
          v_subpricecur = v_subpricecur / v_subquantity;
        end else begin
          v_subpricerub = 0;
          v_subpricecur = 0;
        end
        insert into CASHSAIL_COMPL(shopindex, cashnumber, znumber, checknumber, id,
                                   subarticul, quantity, pricerub, pricecur,
                                   cardarticul, taxhead, mesuriment, collect_kind, rz)
          values (:v_shopindex, :v_cashnumber, :v_znumber, :v_checknumber, :v_id,
                  :v_subarticul, :v_quantity * :v_subquantity, :v_subpricerub, :v_subpricecur,
                  :v_articul, :v_subtaxhead, :v_pack, :v_collectkind, 0); -- rz  =0 ..     
      end
    end
    success = 1;
  end
  suspend;
end^

create or alter procedure XCASH_RET_DONE (
    V_DOCHEAD T_DOC,
    V_DOC_DATE T_DATE_NULL,
    V_MANAGER T_FID,
    V_CLIENT T_FID,
    V_PLACE T_FID,
    V_SHOPINDEX T_FID,
    V_COMMENT T_COMMENT,
    V_OPERATION T_FID)
AS
declare variable v_return double precision;
declare variable v_dockind integer;
declare variable v_doctype integer;
declare variable v_filialindex integer;
declare variable v_cashnumber integer;
declare variable v_articul t_articul_null;
declare variable v_asrt integer;
declare variable v_pack integer;
declare variable v_quantity double precision;
declare variable v_pack_quantity double precision;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
declare variable v_taxhead integer;
declare variable v_pos integer;
declare variable v_i integer;
declare variable n_articul t_articul_null;
declare variable n_asrt integer;
declare variable n_pack integer;
declare variable n_quantity double precision;
declare variable n_pack_quantity double precision;
declare variable n_pack_size double precision;
declare variable n_certificate integer;
declare variable n_pos integer;
declare variable o_asrt integer;
declare variable o_pack integer;
declare variable o_pricerub double precision;
declare variable o_pricecur double precision;
declare variable o_quantity double precision;
--declare variable o_pack_quantity double precision;
declare variable v_collectkind integer;
declare variable c_date date;
declare variable d_date date;
declare variable v_real_time date;
declare variable d_collectkind integer;
declare variable s_articul t_articul_null;
declare variable s_quantity double precision;
declare variable s_pricerub double precision;
declare variable s_pricecur double precision;
declare variable s_pack integer;
declare variable s_asrt integer;
declare variable s_taxhead integer;
declare variable s_collectkind integer;
declare variable is_compl integer;
declare variable v_compl_id integer;
begin

  --  
  d_collectkind = null; --        (  )
  d_date = StrToDateFmt('dd.mm.yyyy','01.01.1900'); --   -     StrToDateFmt  Delphi (    )

  -- v_dochead     z- ..       z-

  v_cashnumber = -1; v_dockind = 0; v_doctype = 1000; v_return = 0;
  if (v_dochead= - 1) then begin
    v_dochead = gen_id(dochead_gen, 1); --   
  end else begin                                          --   
    delete from CURRESTS where shopindex  =:v_shopindex and cashnumber = :v_cashnumber and znumber = :v_dochead;
    update DOCHEAD set doc_state = -1 where id_dochead = :v_dochead;  -- 
    delete from DOCHEAD where id_dochead = :v_dochead;              -- 
  end

  --  
  select filial from GET_FILIAL_FROM_PLACE(:v_place) into :v_filialindex;
  insert into DOCHEAD(id_dochead, shopindex, dochead_filialindex, doctype, docindex, dockind, doc_date,
                      client_index, client2_index, operation, doc_state, manager, comment)
    values(:v_dochead, :v_shopindex, :v_filialindex, :v_doctype, :v_dochead, :v_dockind, :v_doc_date,
           :v_client, :v_place, :v_operation, -1, :v_manager, :v_comment);

  --   
  delete from TMP_CASH_RET_S where cmp_dbl_e(quantity, 0) < 1;

  v_pos = 0; is_compl = 0; v_articul = '<CLASSIF>'; --            
  for select m.articul, m.asrt, m.pack, m.quantity, m.quantity / m.pack_size,
             s.asrt, s.pack, s.quantity, s.quantity / s.pack_size,
             m.pricerub, m.pricecur, m.taxhead, s.certificate, m.cnt
    from XCASH_RET_VIEW(null) m
    left join TMP_CASH_RET_S s on s.articul = m.articul
    where m.cnt > 0
    order by m.articul, m.asrt, m.pack, s.asrt, s.pack
    into :n_articul, :v_asrt, :v_pack, :v_quantity, :v_pack_quantity,
         :n_asrt, :n_pack, :n_quantity, :n_pack_quantity, :v_pricerub, :v_pricecur,
         :v_taxhead, :n_certificate, :v_i
  do begin
    -- v_pos -   docspec    (..      )
    -- n_pos -   docspecext          

    if (v_articul <> n_articul) then begin --   
      v_articul = n_articul; n_pos = 0; v_pos = v_pos + 1;

      --     
      v_collectkind = -1; c_date = d_date; v_compl_id = null;
      if (exists(select 1 from CARDCOMPL_HEADER where articul = :v_articul)) then begin
        --    
        select max(compl_date) from CARDCOMPL_HEADER
          where articul = :v_articul and compl_date <= :v_doc_date into :c_date;
        select compl_id from CARDCOMPL_HEADER
          where articul = :v_articul and compl_date = :c_date into :v_compl_id;
        if (v_compl_id is not null) then begin
          if (exists (select 1 from CARDCOMPL where compl_id = :v_compl_id)) then begin -- ,    " "
            v_collectkind = null;
            select collectkind from CARDCOLLECT where articul = :v_articul and place_index = :v_place into :v_collectkind;
            if (v_collectkind is null) then begin
              v_collectkind = null;
              select collect_kind from CLIENTS where id_clients = :v_place into :v_collectkind;
              if (v_collectkind is null) then begin
                if (d_collectkind is null)
                  then select numparam from CONFIG where paramname = 'CollectKindDefault' into :d_collectkind;
                v_collectkind = d_collectkind;
              end
              if (not exists(select 1 from COLLECTKIND where id = :v_collectkind))
                then v_collectkind = 0;
            end
          end
        end
      end
    end

    n_pos = n_pos + 1;
    --    z-
    v_return = v_return + n_quantity * v_pricerub;
    --   
    v_real_time = 'now'; v_real_time = v_real_time - datetoint(v_real_time);

    --    cashsail
    insert into CASHSAIL(session, shopindex, cashnumber, znumber, checknumber, id, sell_date, sell_time,
                         cardarticul, cardsize, quantity, pricerub, pricecur, totalrub, totalcur, department, casher, usingindex,
                         replace, operation, credcardindex, disccliindex, linked, dochead, taxhead, pack, collect_kind, rz, certificate)
      values(-1, :v_shopindex, :v_cashnumber, :v_dochead, :v_pos, :n_pos, :v_doc_date, :v_real_time,
             :v_articul, '-', :n_quantity, :v_pricerub, :v_pricecur, :n_quantity * :v_pricerub, :n_quantity * :v_pricecur, 0, :v_manager, :v_place,
             :v_dockind, :v_operation, 0, 0, 0, :v_dochead, :v_taxhead, :n_pack, :v_collectkind, :n_asrt, :n_certificate);

    if (v_collectkind <> 1) then begin
      --     
      if (n_pos = 1) then begin --        
        --     docspec (vic   xcash_collect_docs  doc_quantity  ..        )
        insert into DOCSPEC(id_dochead, articul, pos_number, quantity,
                            pricerub, pricecur, pricerub_1, pricecur_1,
                            mesuriment, pack_quantity, taxhead, rz)
          values(:v_dochead, :v_articul, :v_pos, :v_quantity,
                 :v_pricerub, :v_pricecur, null, null,
                 :v_pack, :v_pack_quantity, :v_taxhead, :v_asrt);
        if (v_pack = -1 or v_asrt = -1) then begin
          --    , -      docspec       
          update DOCSPEC set quantity = :v_quantity, pack_quantity = :v_pack_quantity, update_price = 'F'
            where id_dochead = :v_dochead and articul = :v_articul;
        end
      end

      if (v_i > 1) then begin --      
        --     docspecext
        insert into DOCSPECEXT(dochead, articul, id, pos_number, mesuriment, quantity, pack_quantity,
                               pricerub, pricecur, pricerub_1, pricecur_1, update_price, rz, update_quant)
          values(:v_dochead, :v_articul, :n_pos, :n_pos, :n_pack, :n_quantity, :n_pack_quantity,
                 :v_pricerub, :v_pricecur, null, null, 'F', :n_asrt, 'F');
      end

    end else begin
      --     
      is_compl = 1; --           docspec_collect     (   cashsail_compl)
      --      v_i  ..  v_i > 1       
      --         
      for select articul, sum(quantity), sum(quantity * pricerub), sum(quantity * pricecur)
        from COMPLECT_GETCARDS(:v_shopindex, :v_filialindex, :v_place, :v_articul,
                               :v_pricerub,: v_pricecur, 'F', :v_doc_date)
        group by articul
        into :s_articul, :s_quantity, :s_pricerub, :s_pricecur
      do begin
        --    
        s_collectkind = -1; c_date = d_date; v_compl_id = null;
        if (exists(select 1 from CARDCOMPL_HEADER where articul = :s_articul)) then begin
          --     
          select max(compl_date)
            from CARDCOMPL_HEADER where articul = :s_articul and compl_date <= :v_doc_date
          into :c_date;
          select compl_id
            from CARDCOMPL_HEADER where articul = :s_articul and compl_date = :c_date
          into :v_compl_id;
          if (v_compl_id is not null) then begin
            if (exists (select 1 from CARDCOMPL where compl_id = :v_compl_id)) then begin -- ,    " "
              s_collectkind = null;
              select collectkind from CARDCOLLECT where articul = :s_articul and place_index = :v_place into :s_collectkind;
              if (s_collectkind is null) then begin
                select collect_kind from CLIENTS where id_clients = :v_place into :s_collectkind;
                if (s_collectkind is null) then begin
                  if (d_collectkind is null) then select numparam from CONFIG where paramname = 'CollectKindDefault' into :d_collectkind;
                  s_collectkind = d_collectkind;
                end
                if (not exists(select 1 from collectkind where id = :s_collectkind)) then s_collectkind = 0;
              end
            end
          end
        end

        s_asrt = 0; --     
        s_pack = null; s_taxhead = null;
        select mesuriment from CARDSCLA where articul = :s_articul into :s_pack;
        select taxhead from XCASH_GET_TAXHEAD(:v_shopindex, :v_cashnumber, :v_operation, :s_articul) into :s_taxhead;
        if (cmp_dbl_e(s_quantity, 0) <> 0) then begin
          s_pricerub = s_pricerub / s_quantity;
          s_pricecur = s_pricecur / s_quantity;
        end else begin
          s_pricerub = 0; s_pricecur = 0;
        end
        --  cashsail_compl
        insert into CASHSAIL_COMPL(shopindex, cashnumber, znumber, checknumber, id, subarticul,
                                   quantity, pricerub, pricecur, cardarticul, taxhead, mesuriment, collect_kind, rz)
          values(:v_shopindex, :v_cashnumber, :v_dochead, :v_pos, :n_pos, :s_articul,
                 :n_quantity * :s_quantity, :s_pricerub, :s_pricecur, :v_articul, :s_taxhead, :s_pack, :s_collectkind, :s_asrt);
        -- ..         docspec_collect
        insert into DOCSPEC_COLLECT(dochead, articul, shopindex, cashnumber, znumber, checknumber, id, salearticul,
                                    quantity, pack, pricerub, pricecur, pricerub_1, pricecur_1, taxhead, rz)
          values(:v_dochead, :s_articul, :v_shopindex, :v_cashnumber, :v_dochead, :v_pos, :n_pos, :v_articul,
                 :n_quantity * :s_quantity, :s_pack, :s_pricerub, :s_pricecur, 0, 0, :s_taxhead, :s_asrt);
      end
    end
  end

  if (is_compl = 1) then begin
    --      
    v_articul = '<CLASSIF>'; --            
    --  v_pos    0 ..   
    for select articul, rz, pack, min(taxhead), sum(quantity), sum(quantity * pricerub), sum(quantity * pricecur)
      from DOCSPEC_COLLECT where dochead = :v_dochead
      group by articul, rz, pack
      into :n_articul, :n_asrt, :n_pack, :v_taxhead, :n_quantity, :v_pricerub, :v_pricecur
    do begin
      if (cmp_dbl_e(n_quantity, 0) > 0) then begin -- vic     ..   (      xcash_collect_docs   xcash_collect_docs_bycash  )
        v_pricerub = v_pricerub / n_quantity; v_pricecur = v_pricecur / n_quantity;

        if (v_articul <> n_articul) then begin --   
          --        (   -     /   )
          o_asrt = null;
          select rz, mesuriment, pricerub, pricecur, quantity
            from DOCSPEC where id_dochead = :v_dochead and articul = :n_articul
          into :o_asrt, :o_pack, :o_pricerub, :o_pricecur, :o_quantity;
        end

        if (o_asrt is null) then begin
          --          
          if (v_articul <> n_articul) then begin --   
            --     docspec
            v_articul = n_articul; v_asrt = n_asrt; v_pack = n_pack;
            n_pos = 1; v_pos = v_pos + 1; --   
            insert into DOCSPEC(id_dochead, articul, pos_number, quantity,
                                pricerub, pricecur, pricerub_1, pricecur_1, mesuriment, taxhead, rz)
              values(:v_dochead, :v_articul, :v_pos, :n_quantity,
                     :v_pricerub, :v_pricecur, null, null, :v_pack, :v_taxhead, :v_asrt);
          end

          if (v_asrt <> n_asrt or v_pack <> n_pack) then begin
            --        
            --     docspecext
            --      docspec   
            if (v_asrt <> -1 and v_asrt <> n_asrt or v_pack <> -1 and v_pack <> n_pack) then begin
              if (v_asrt <> n_asrt) then v_asrt = -1;
              if (v_pack <> n_pack) then v_pack = -1;
              update DOCSPEC set mesuriment = :v_pack, rz = :v_asrt where id_dochead = :v_dochead and articul = :v_articul;
            end

            n_pos = n_pos + 1;

            n_pack_size = null;
            select quantity_mesurim from MESURIMENT where id_mesuriment = :n_pack into :n_pack_size;
            if (cmp_dbl_e(n_pack_size, 0) < 1) then n_pack_size = 1;
            n_pack_quantity = n_quantity / n_pack_size;

            insert into DOCSPECEXT(dochead, articul, id, pos_number, mesuriment, quantity, pack_quantity,
                                   pricerub, pricecur, pricerub_1, pricecur_1, update_price, rz, update_quant)
              values(:v_dochead, :v_articul, :n_pos, :n_pos, :n_pack, :n_quantity, :n_pack_quantity,
                     :v_pricerub, :v_pricecur, null, null, 'F', :n_asrt, 'T');

          end
        end else begin
          --         
          if (v_articul <> n_articul) then begin --   
            v_articul = n_articul; v_asrt = o_asrt; v_pack = o_pack;
          end

          n_pack_size = null;
          select quantity_mesurim from MESURIMENT where id_mesuriment = :n_pack into :n_pack_size;
          if (cmp_dbl_e(n_pack_size, 0) < 1) then n_pack_size = 1;
          n_pack_quantity = n_quantity / n_pack_size;

          if (v_asrt = n_asrt and v_pack = n_pack) then begin
            --        
            --            
            --     

            --   o_...     docspec
            v_quantity = o_quantity + n_quantity; --      v_quantity, o_quantity, n_quantity >0
            v_pack_quantity = v_quantity / n_pack_size;
            if (o_pricerub <> v_pricerub or o_pricerub <> v_pricerub) then begin
              v_pricerub = (o_quantity * o_pricerub + n_quantity * v_pricerub) / v_quantity;
              v_pricecur = (o_quantity * o_pricecur + n_quantity * v_pricecur) / v_quantity;
            end
            update DOCSPEC set
                quantity = :v_quantity, pack_quantity = :v_pack_quantity,
                pricerub = :v_pricerub, pricecur = :v_pricecur,
                update_price = 'F'
              where id_dochead = :v_dochead and articul = :v_articul;

          end else begin
            --     docspecext
            --      docspec   
            if (v_asrt <> -1 and v_asrt <> n_asrt or v_pack <> -1 and v_pack <> n_pack) then begin
              if (v_asrt <> n_asrt) then v_asrt = -1; if (v_pack <> n_pack) then v_pack = -1;
              update DOCSPEC set mesuriment = :v_pack, rz = :v_asrt where id_dochead = :v_dochead and articul = :v_articul;
            end

            v_i = null;
            select id, quantity, pricerub, pricecur
              from DOCSPECEXT
              where dochead = :v_dochead and articul = :v_articul and mesuriment = :n_pack and rz = :n_asrt
            into :v_i, :o_quantity, :o_pricerub, :o_pricecur;
            --   o_...     docspecext
            if (v_i is null) then begin
              insert into DOCSPECEXT(dochead, articul, mesuriment, quantity, pack_quantity,
                                     pricerub, pricecur, pricerub_1, pricecur_1, update_price, rz, update_quant)
                values(:v_dochead, :v_articul, :n_pack, :n_quantity, :n_pack_quantity,
                       :v_pricerub, :v_pricecur, null, null, 'F', :n_asrt, 'T');
            end else begin
              v_quantity = o_quantity + n_quantity; --      v_quantity, o_quantity, n_quantity >0
              v_pack_quantity = v_quantity / n_pack_size;
              if (o_pricerub <> v_pricerub or o_pricerub <> v_pricerub) then begin
                v_pricerub = (o_quantity * o_pricerub + n_quantity * v_pricerub) / v_quantity;
                v_pricecur = (o_quantity * o_pricecur + n_quantity * v_pricecur) / v_quantity;
              end
              update DOCSPECEXT set
                  quantity = :v_quantity, pack_quantity = :v_pack_quantity,
                  pricerub = :v_pricerub, pricecur = :v_pricecur,
                  update_price = 'F', update_quant = 'T'  --      docspec        b_price=1
                where dochead = :v_dochead and articul = :v_articul and id = :v_i;
            end
          end

        end
      end
    end
  end

  --     z- (..  )
  --              ,  -    
  delete from CURRESTS where shopindex = :v_shopindex and znumber = :v_dochead and cashnumber = :v_cashnumber;
  insert into CURRESTS(shopindex, cashnumber, znumber, date_begin, sale, ret, storno, stornret, result, session)
    values(:v_shopindex, :v_cashnumber, :v_dochead, :v_doc_date, 0, :v_return, 0, 0, -1 * :v_return, -1);

  -- xcash_compldoc                  

  --     
  update DOCHEAD set doc_state = -2 where id_dochead =:v_dochead;
  if (is_compl = 1) --     is_compl=0   complect_compens_make   
    then execute procedure COMPLECT_COMPENS_MAKE(:v_dochead);
end^

create or alter procedure XCASH_RET_SPEC_ADD (
    SESSION T_FID,
    ARTICUL T_ARTICUL_NULL,
    ASRT T_FID,
    PACK T_FID,
    QUANTITY T_QUANTITY_NULL,
    PRICERUB T_MONEY_NULL,
    PRICECUR T_MONEY_NULL,
    TAXHEAD T_FID,
    CERTIFICATE T_FID,
    SHOPINDEX T_FID,
    FILIALINDEX T_FID,
    REWRITE_QUANT T_FID)
returns (
    RESULT T_CHAR)
AS
declare variable v_add_quantity integer;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
declare variable v_quantity double precision;
declare variable v_pack_size double precision;
declare variable v_taxhead integer;
declare variable v_certificate integer;
begin
  --       
  --   quantity -    pack
  --   rewrite_quant         
  --    rewrite_quant<0  rewrite_quant=null    rewrite_quant
  --          SpecAddQuantity

  --     ..     ,
  --          - 

  --    
  if (session is null or articul is null) then exit;

  if (asrt is null) then asrt = -1;
  if (pack is null) then pack = -1;
  if (cmp_dbl_e(quantity, 0) = 0) then quantity = 0;
  if (cmp_dbl_e(pricerub, 0) < 1) then pricerub = 0; --   
  if (cmp_dbl_e(pricecur, 0) < 1) then pricecur = 0;

  if (shopindex is null)
    then select v_num from PARAMS where session = :session and class = 'Common' and name = 'ShopIndex' into :shopindex;
  if (filialindex is null)
    then select v_num from PARAMS where session = :session and class = 'Common' and name = 'FilialIndex' into :filialindex;
  if (shopindex is null or filialindex is null) then exit;

  if (rewrite_quant is null)
    then rewrite_quant = -1;
    else rewrite_quant = cmp_dbl_e(rewrite_quant, 0);
  if (taxhead is null) then taxhead = -1;
  if (asrt = -1) then asrt = 0;
  if (pack = -1)
    then select mesuriment from CARDSCLA where articul = :articul into :pack;

  if (rewrite_quant < 0) --         (  )
    then if (exists(select 1
                      from CUR_USER u
                      inner join CONFIG_USER c on c.id_user = u.id and c.paramname = 'SpecAddQuantity' and c.boolparam = 'T'))
           then v_add_quantity = 1;
           else v_add_quantity = 0;
    else v_add_quantity = 1 - rewrite_quant; --        (  )

  if (cmp_dbl_e(abs(quantity), 0) = 0) then quantity = 0;
  --    

  --  -
  v_taxhead = null;
  select pricerub, pricecur, taxhead
    from TMP_CASH_RET_M where articul = :articul
  into :v_pricerub, :v_pricecur, :v_taxhead;

  if (taxhead <> -1) then v_taxhead = taxhead; else if (v_taxhead is null) then v_taxhead = -1;
  if (v_taxhead = -1) then begin
    --   
    select taxhead from XCASH_GET_TAXHEAD(:shopindex, -1, 9, :articul)
      into :v_taxhead;
    if (v_taxhead is null) then v_taxhead = -1;
  end

  if (v_pricerub is null) then begin --    -,    
    --  
    if (pricerub = 0 and pricecur = 0) then begin
      select p.price_rub, p.price_cur
        from PRICEKIND k
        left join GET_PRICE2(:articul, k.id_pricekind) p on 1=1
        where k.shopindex_pricekind = :shopindex and
              k.filialindex_pricekind = :filialindex and k.kind = 0 -- - 
      into :v_pricerub,:v_pricecur;
    end else begin
      v_pricerub = pricerub; v_pricecur = pricecur;
    end

    insert into TMP_CASH_RET_M(articul, pricerub, pricecur, taxhead)
      values(:articul, :v_pricerub, :v_pricecur, :v_taxhead);
  end else begin
    if ((pricerub <> 0 or pricecur <> 0) and
        (pricerub <> v_pricerub or
         pricerub = v_pricerub and pricecur <> 0 and pricecur <> v_pricecur)) then begin
      v_pricerub = pricerub; v_pricecur = pricecur;
    end
    update TMP_CASH_RET_M set pricerub = :pricerub, pricecur = :pricecur, taxhead = :v_taxhead
      where articul = :articul;
  end

  --  -
  v_certificate = null;
  select pack_size, quantity, certificate
    from TMP_CASH_RET_S
    where articul = :articul and asrt = :asrt and pack = :pack
  into :v_pack_size, :v_quantity, :v_certificate;

  if (certificate is not null) then begin
    if (v_certificate is not null and v_certificate = certificate)
      then certificate = null;
      else v_certificate = certificate;
  end

  if (v_pack_size is null) then begin
    select quantity_mesurim from MESURIMENT where id_mesuriment = :pack into :v_pack_size;
    if (cmp_dbl_e(v_pack_size, 0) < 1) then v_pack_size = 1;
    v_quantity = quantity * v_pack_size;
    insert into TMP_CASH_RET_S(articul, asrt, pack, pack_size, quantity, certificate)
      values(:articul, :asrt, :pack, :v_pack_size, :v_quantity, :v_certificate);
  end else begin
    if (v_add_quantity = 1 and quantity = 0 and certificate is null) then begin result = 'T'; suspend; end

    if (v_add_quantity = 1)
      then v_quantity = v_quantity + quantity * v_pack_size;
      else v_quantity = quantity * v_pack_size;
    update TMP_CASH_RET_S set quantity = :v_quantity, certificate = :v_certificate
      where articul = :articul and asrt = :asrt and pack = :pack;
  end
  result = 'T';
  suspend;
end^

set term ; ^





-- SM-3334

ALTER TABLE VID_PROD ADD NO_RECEIPT T_INT_BOOLEAN DEFAULT 0;
COMMENT ON COLUMN VID_PROD.NO_RECEIPT IS '        .';


CREATE TABLE EGAIS_IN_TTN_DISABLED (
    DOC_DATE   T_DATE NOT NULL /* T_DATE = DATE NOT NULL */,
    NUMBER     T_STRING50 NOT NULL /* T_STRING50 = VARCHAR(50) */,
    SHIPPER    T_STRING50 NOT NULL /* T_STRING50 = VARCHAR(50) */,
    CONSIGNEE  T_STRING50 NOT NULL /* T_STRING50 = VARCHAR(50) */
);
ALTER TABLE EGAIS_IN_TTN_DISABLED ADD CONSTRAINT PK_EGAIS_IN_TTN_DISABLED PRIMARY KEY (DOC_DATE, NUMBER, SHIPPER, CONSIGNEE);
COMMENT ON TABLE EGAIS_IN_TTN_DISABLED IS ' ,         .';
COMMENT ON COLUMN EGAIS_IN_TTN_DISABLED.DOC_DATE IS ' ';
COMMENT ON COLUMN EGAIS_IN_TTN_DISABLED.NUMBER IS ' ';
COMMENT ON COLUMN EGAIS_IN_TTN_DISABLED.SHIPPER IS ' ';
COMMENT ON COLUMN EGAIS_IN_TTN_DISABLED.CONSIGNEE IS ' ';
GRANT ALL ON EGAIS_IN_TTN_DISABLED TO PUBLIC;




-- SM-3312

set term ^ ;

CREATE OR ALTER TRIGGER EGAIS_IN_ACTS_BIU_STATE FOR EGAIS_IN_ACTS
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
as
declare variable TTN_STATE integer;
begin
  --      :
  --  0,1,2   3,10,11,18  - 
  --  9   3,10,11,19
  --  3,4,5,10,11   5,6,12   - 

  --  5 () .    ,      ,
  --    TransportId  ReplyId .
  --        , ..      ,     .
  --     7 ().
  TTN_STATE = null;

  if (new.ACT_KIND in (0,2,9) and new.STATE = 5) then --       
    TTN_STATE = 5;
  if (new.ACT_KIND in (0,2,9) and new.STATE = 7) then --       
    TTN_STATE = 9;
  if (new.ACT_KIND in (1) and new.STATE = 7) then --     
    TTN_STATE = 7;

--      .
-- 1.      -          * ACT_KIND =1,
-- 2.      - 
-- 3.      - 
-- 4.      - 
-- 5.     - 

  debug_log('EGAIS_IN_ACTS_BIU:   '||new.ACT_KIND||'  '||new.STATE||'   '||coalesce(:TTN_STATE,'NULL'));


  --              "   "
  --        / 
  if (new.ACT_KIND = 9 and new.STATE = 10) then
  begin
    update EGAIS_IN_ACTS
       set STATE = 18             --     
     where ACT_KIND in (0,1,2)
       and STATE = 11             --    
       and WB_REG_ID = new.WB_REG_ID;

    update EGAIS_IN_ACTS
       set STATE = 18             --     
     where ACT_KIND in (3,4)      --  / 
       and STATE = 12             --  
       and WB_REG_ID = new.WB_REG_ID;
  end

  --    ()   ,     
  if (new.ACT_KIND = 9 and new.STATE = 3) then
  begin
    update EGAIS_IN_ACTS
       set STATE = 11  --    
     where STATE = 18  --     
       and ACT_KIND in (0,1,2)
       and WB_REG_ID = new.WB_REG_ID;

    update EGAIS_IN_ACTS
       set STATE = 12  -- 
     where STATE = 18  --     
       and ACT_KIND in (3,4)
       and WB_REG_ID = new.WB_REG_ID;
  end

  --     ( )   ,     
  if (new.ACT_KIND = 11 and new.STATE = 12) then
  begin
    update EGAIS_IN_ACTS
       set STATE = 11  --    
     where STATE = 18  --     
       and ACT_KIND in (0,1,2)
       and WB_REG_ID = new.WB_REG_ID;

    update EGAIS_IN_ACTS
       set STATE = 12  -- 
     where STATE = 18  --     
       and ACT_KIND in (3,4)
       and WB_REG_ID = new.WB_REG_ID;
  end

  --      ( 9  19)      ,
  --        18
  if (new.ACT_KIND = 9 and new.STATE = 6) then -- Accepted-UnConfirm     
  begin
  --    0,1,2   
  --     kind / 
    update EGAIS_IN_ACTS
       set STATE = 19             --  
     where ACT_KIND in (0,1,2)
       and STATE = 18             --     
       and WB_REG_ID = new.WB_REG_ID;

    TTN_STATE = 9;
  end

  --  . .   .
--  if (new.ACT_KIND = 4 and new.STATE = 12) then
--    TTN_STATE = 6; --  ,    EGAIS_IN_DOCHEAD_BU0

  if (TTN_STATE is not null) then
  begin
    update EGAIS_IN_DOCHEAD
       set STATE = :TTN_STATE,
           EGAIS_COMMENT = new.TICKET_COMMENT
     where EGAIS_REG_ID = new.WB_REG_ID
       and USERS_STATE = 0;
    debug_log('EGAIS_IN_ACTS_BU:    '||:TTN_STATE);
  end


  if (new.STATE = 5) then
    new.STATE = old.STATE; -- ,  insert     5  ,  update
  if (new.STATE = 7) then
  begin
    new.STATE = old.STATE;
    update EGAIS_IN_ACTS
       set STATE = 19
     where STATE = 18
       and WB_REG_ID = new.WB_REG_ID;
  end
  debug_log('EGAIS_IN_ACTS_BU:    '||new.STATE);
end^

create or alter procedure AXAPTA_IMPDOCHEADER (
    STAGE_ID T_FID)
returns (
    DOCHEADERID T_FID,
    OPERATIONTYPEID T_FID,
    DOCFLOWID T_FID,
    STOREID T_FID,
    DOCNUM T_STR20,
    DOCDATE T_DATE_NULL,
    CONTRAGENTID T_FID,
    LOCATIONIDFROM T_FID,
    LOCATIONIDTO T_FID,
    TOTALAMOUNT T_MONEY_NULL,
    TOTALQTY T_QUANTITY_NULL,
    DOCINVOICEID T_STR20,
    DOCINVOICEDATE T_DATE_NULL,
    DOCFACTUREID T_STR20,
    DOCFACTUREDATE T_DATE_NULL,
    ISPACKAGE T_INT_VALUE,
    comment T_COMMENT,
    DOCIDSM T_FID,
    TIMEARRIVAL T_DATE_NULL,
    NAMERECEIVER T_STRING60_NULL,
    VOLUME T_QUANTITY_NULL,
    NULLDATE T_DATE_NULL)
AS
declare variable v_DocNum t_str20;
declare variable v_num_tn t_num_tn;
declare variable v_time_arival t_add_param;
declare variable v_namereceiver t_add_param;
declare variable v_date t_int_value;
declare variable v_date2 t_int_value;
declare variable v_doinv smallint;
begin
  ispackage = 0;
  nulldate = '1900-01-01';
  v_date = gen_id(axapta_date_gen,0);
  v_date2 = datetoint(current_timestamp);
  if (v_date2 > v_date) then begin
    if (exists(select 1 from OVS_STAGE where id = :stage_id and axapta_time is null))
      then v_doinv = 1;
      else v_doinv = 0;
    if (v_doinv = 0)
      then if (exists(select 1 from OVS_STAGE
                        where id = :stage_id and
                              ((extract(hour from current_timestamp) * 100 + extract(minute from current_timestamp)) -
                               (extract(hour from axapta_time) * 100 + extract(minute from axapta_time))) >= 0))
             then v_doinv = 1;
    if (v_doinv = 1) then begin
      docinvoiceid = '';
      docnum = '';
      namereceiver = v_namereceiver;
      operationtypeid = coalesce(operationtypeid, 0);
      storeid = coalesce(storeid, 0);
      contragentid = coalesce(contragentid, 0);
      locationidfrom = coalesce(locationidfrom, 0);
      locationidto = coalesce(locationidto, 0);
      totalamount = coalesce(totalamount, 0);
      totalqty = coalesce(totalqty, 0);
      docfactureid = coalesce(docfactureid, '');
      comment = coalesce(comment, '');
      docidsm = coalesce(docidsm, 0);
      timearrival = coalesce(timearrival, '1900-01-01');
      docinvoicedate = coalesce(docinvoicedate, '1900-01-01');
      namereceiver = coalesce(namereceiver, '');
      docfacturedate = coalesce(docfacturedate, '1900-01-01');
      volume = 0;
      docflowid = 46;
      docheaderid = gen_id(dochead_gen, 1);
      docdate = current_timestamp;
      suspend;
    end
  end
  v_DocNum = '';
  -- comment must be cutted low to 250 characters, num_tn from 256--->20
  for select dh.id_dochead, dh.operation, coalesce(ova.docflow_id, 43), dh.dochead_filialindex, dp.axapta_num, dh.doc_date,
             dh.client_index, dh.client2_index, dh.totalrub, sum(ds.quantity), left(coalesce(dh.ext_docindex,''),20),
             coalesce(dh.ext_doc_date, '1900-01-01'), dp.num_tn, coalesce(dp.date_tn, '1900-01-01'),
             dh.comment, dh.id_dochead, dh.add_param9, dh.add_param5, dsa.num_value
    from DOCHEAD_OVS dov
    inner join DOCHEAD dh on dh.id_dochead = dov.dochead and dh.accept = 'T'
    left join OVS_AXAPTA ova on ova.ovs_id = dov.ovs_kind and ova.doctype_id = dh.doctype and ova.operation_id = dh.operation
    left join AXAPTA_DOCFLOW adf on adf.is_import = 0 and adf.docflowid = ova.docflow_id
    left join DOCHEAD_PARAMS dp on dp.dochead = dh.id_dochead
    left join DOCSPEC ds on ds.id_dochead = dh.id_dochead
    left join DOCHEAD_SMREF_ADD dsa on dsa.kind = 25 and dsa.id_dochead = dh.id_dochead
    where dov.ovs_kind = :stage_id and dov.post_status = 20 and
          ((ova.ovs_id is not null and adf.docflowid is not null) or (dh.doctype in (1000,1001)))
    group by dh.id_dochead, dh.operation, ova.docflow_id, dh.dochead_filialindex, dp.axapta_num, dh.doc_date,
             dh.client_index, dh.client2_index, dh.totalrub, dh.ext_docindex, dp.num_tn,
             dh.comment, dh.id_dochead, dh.add_param9, dh.add_param5, dsa.num_value, dh.ext_doc_date, dp.date_tn
    order by dp.axapta_num, ova.docflow_id
  into :DocHeaderId, :OperationTypeId, :DocFlowId, :StoreId, :DocNum, :DocDate,
       :ContragentId, :LocationIdFrom, :TotalAmount, :TotalQty, :DocInvoiceId,
       :DocInvoiceDate, :v_num_tn, :DocFactureDate,
       :Comment, :DocIdSM, :v_time_arival, :v_namereceiver, :Volume
  do begin
    if (not exists(select 1
                     from DOCHEAD dh
                     inner join OPERATIONS oper on oper.id_operation = dh.operation and oper.is_package = 1
                     inner join DOCSPEC ds on ds.id_dochead = dh.id_dochead
                     inner join CARDSCLA cc on cc.articul = ds.articul
                     inner join CARDTYPES cts on cts.id_cardtype = cc.cardtype and cts.cardkind <> 2
                     where dh.id_dochead = :DocHeaderId)) then begin
      if (DocFlowId in (45,20)) then begin
        locationidto = locationidfrom;
        locationidfrom = 0;
      end else locationidto = null;
      if (trim(coalesce(v_num_tn, '')) = '')
        then v_num_tn = null;
        else v_num_tn = trim(v_num_tn);
      if (v_num_tn is not null) then begin
        if (char_length(v_num_tn) > 20) then v_num_tn = left(v_num_tn, 20);
      end
      DocFactureId = v_num_tn;
      if (trim(coalesce(docnum, '')) = '')
        then docnum = null;
        else docnum = trim(docnum);
      if (trim(coalesce(comment, '')) = '')
        then comment = null;
        else comment = trim(comment);
      if (comment is not null) then begin
        if (char_length(Comment) > 250) then comment = left(comment, 250);
      end
      if (trim(coalesce(v_time_arival, '')) = '')
        then v_time_arival = null;
        else v_time_arival = trim(v_time_arival);
      if (v_time_arival is not null) then begin
        TimeArrival = strtodate(v_time_arival);
        if (TimeArrival = strtodate('fdfdf')) then TimeArrival = null;
      end
      if (trim(coalesce(v_namereceiver, '')) = '')
        then v_namereceiver = null;
        else v_namereceiver = trim(v_namereceiver);
      if (v_namereceiver is not null) then begin
        if (char_length(v_namereceiver) > 60) then v_namereceiver = left(v_namereceiver, 60);
      end
      NameReceiver = v_namereceiver;
      operationtypeid = coalesce(operationtypeid, 0);
      docflowid = coalesce(docflowid, 0);
      storeid = coalesce(storeid, 0);
      contragentid = coalesce(contragentid, 0);
      locationidfrom = coalesce(locationidfrom, 0);
      locationidto = coalesce(locationidto, 0);
      totalamount = coalesce(totalamount, 0);
      totalqty = coalesce(totalqty, 0);
      docfactureid = coalesce(docfactureid, '');
      comment = coalesce(comment, '');
      docidsm = coalesce(docidsm, 0);
      timearrival = coalesce(timearrival, '1900-01-01');
      namereceiver = coalesce(namereceiver, '');
      volume = coalesce(volume, 0);
      -- 1
      if (DocFlowId = 20 and (docnum is not null) and (docdate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
      -- 2
      if (DocFlowId = 23 and (DocInvoiceId is not null) and (docdate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        select dp.axapta_num
          from PARTSPEC ps
          inner join DOCHEAD_PARAMS dp on dp.dochead = ps.indochead
          where ps.dochead = :DocHeaderId and dp.axapta_num is not null
          rows 1
        into :docnum;
        docnum = coalesce(docnum, '');
        suspend;
      end
      -- 3
      if (DocFlowId = 27 and (DocDate is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
      -- 4
      if (DocFlowId = 31 and (DocInvoiceId is not null)) then begin
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        select dp.axapta_num
          from RETSPEC ps
          inner join DOCHEAD_PARAMS dp on dp.dochead = ps.outdochead
          where ps.dochead = :DocHeaderId and dp.axapta_num is not null
          rows 1
        into :docnum;
        docnum = coalesce(docnum, '');
        suspend;
      end
      -- 5
      if (DocFlowId = 33 and (docnum is not null)) then
        if (v_DocNum <> DocNum) then
          if (not exists(select 1
                           from DOCHEAD_PARAMS dp
                           left join DOCHEAD dh on dp.dochead = dh.id_dochead
                           where dp.axapta_num = :docnum and dh.accept = 'F')) then begin
            select coalesce(sum(dh.totalrub), 0), coalesce(sum(ds.quantity), 0)
              from DOCHEAD_PARAMS dp2
              inner join DOCHEAD_OVS dov on dov.dochead = dp2.dochead and dov.post_status = 20 and dov.ovs_kind = :stage_id
              inner join DOCHEAD dh on dh.id_dochead = dp2.dochead
              inner join OVS_AXAPTA ova on ova.ovs_id = :stage_id and ova.doctype_id = dh.doctype and ova.operation_id = dh.operation and ova.docflow_id = 33
              inner join DOCSPEC ds on dh.id_dochead = ds.id_dochead
              where dp2.axapta_num = :docnum
            into :TotalAmount, :TotalQty;
            docnum = coalesce(docnum,'');
            docdate = coalesce(docdate,'1900-01-01');
            docinvoiceid = coalesce(docinvoiceid,'');
            v_DocNum = DocNum;
            suspend;
          end
      -- 6
      if (DocFlowId in (35,36,38,40,41,42,43,45)) then begin
        if (docflowid = 36) then begin
          locationidto = locationidfrom;
          locationidfrom = contragentid;
          contragentid = 0;
        end
        docnum = coalesce(docnum, '');
        docdate = coalesce(docdate, '1900-01-01');
        docinvoiceid = coalesce(docinvoiceid, '');
        suspend;
      end
    end
  end
end^

--axapta^

ALTER TABLE DOCHEAD_PARAMS
ADD LOCK_RET_OPER T_INT_BOOLEAN^

UPDATE DOCHEAD_PARAMS
SET LOCK_RET_OPER = 0^

CREATE EXCEPTION E_OPRETGROUP_TWO_SAME '        '^

INSERT INTO SUPERPLACE_KIND (ID, NAME, COMMENT, ONLY_ONE, C1, C2, C3, C4, C5) VALUES (13, ' ', ' Axapta', 1, NULL, NULL, NULL, NULL, NULL)^

create or alter procedure AXAPTA_GROUPLOCATION (
    GROUPLOCATIONID T_FID,
    NAME t_full_name_null)
returns (
    ERR T_STRING100_NULL)
AS
  declare variable v_name t_name_null;
begin
  name = trim(coalesce(name, ''));
  if (char_length(name) > 40) then
    v_name = left(name, 40);
  else
    v_name = name;
  if (v_name='') then
  begin
    if (err is null) then
      err = '  Name';
    else
      err = err || ',   Name';
  end
  else
  begin
    if (exists(select 1 from SUPERPLACE_HEAD c where c.name=:v_name)) then
      if (err is null) then
        err = '   Name  ';
      else
        err = err || ',    Name  ';
  end
  /*if (exists(select 1 from SUPERPLACE_HEAD c where c.id=:GROUPLOCATIONID)) then
      if (err is null) then
        err = '   GROUPLOCATIONID  ';
      else
        err = err || ',    GROUPLOCATIONID  ';   */
  if (err is null) then
    update or insert into SUPERPLACE_HEAD(ID,SPKIND,NAME,IS_USED) values(:GROUPLOCATIONID,13,:v_name,'T');
  suspend;
end^

grant execute on procedure AXAPTA_GROUPLOCATION to public^

create or alter procedure AXAPTA_INVENTLOCATION (
    INVENTLOCATIONID T_FID,
    INVENTLOCATIONNUM T_STR20,
    NAME T_FULL_NAME_NULL,
    CITY T_INT_VALUE,
    ADDRES T_STR_VALUE,
    STOREID T_INT_VALUE,
    GROUPLOCATIONID T_INT_VALUE)
returns (
    ERR T_STRING100_NULL)
as
declare variable ERR_ T_STR4096;
begin
  if (city = 0) then
    city = null;
  if (InventLocationId is null) then
    err_ = '  InventLocationId';
  if (trim(coalesce(name,''))='') then
    if (err_ is null) then
      err_ = '  Name';
    else
      err_ = err_ || ',   Name';
  if (StoreId is null) then
  begin
    if (err_ is null) then
      err_ = '  StoreId';
    else
      err_ = err_ || ',   StoreId';
  end
  else
  begin
    if (not exists(select 1 from th_classif th where th.parent_id<>-1 and th.id_th_classif=:storeid)) then
      if (err_ is null) then
        err_ = '  StoreId';
      else
        err_ = err_ || ',   StoreId';
  end
  if (not(city is null)) then
  begin
    if (not exists(select 1 from city cit where cit.id_city = :City)) then
      if (err_ is null) then
        err_ = '   SM(City)';
      else
        err_ = err_ || ',   City';
  end
  if (GROUPLOCATIONID <> 0) then
    if (not exists(select 1 from SUPERPLACE_HEAD s where s.spkind=13 and s.id=:GROUPLOCATIONID)) then
      if (err_ is null) then
        err_ = '  GROUPLOCATIONID';
      else
        err_ = err_ || ',   GROUPLOCATIONID';
  if (char_length(err_) >= 100) then
    err = left(ERR_, 95) || '...';
  else
    err = err_;
  if (err is null) then
  begin
    if (GROUPLOCATIONID = 0) then
      delete from SUPERPLACE s where s.spkind=13 and s.placeindex=:InventLocationId;
    else
      update or insert into SUPERPLACE(ID,PLACEINDEX,IS_USED,MODDATE) values(:GROUPLOCATIONID,:InventLocationId,'T',current_timestamp);
    update or insert into Clients(client_type,id_clients,IDENT_CLIENTS,Name_clients,City_clients,Addres_clients,classif)
                           values(1,:InventLocationId,:InventLocationNum,:Name,:City,:Addres,:StoreId);
    update or insert into TH_CLASSBYCLIENT(th_classif, client_index) values(:StoreId,:InventLocationId);
  end
  suspend;
end^

CREATE TABLE OPRETGROUP_HEAD (
    ID            T_ID /* T_ID = INTEGER NOT NULL */,
    NAME          T_NAME NOT NULL COLLATE PXW_CYRL /* T_NAME = VARCHAR(40) NOT NULL */,
    COMMENT       T_COMMENT COLLATE PXW_CYRL /* T_COMMENT = VARCHAR(255) */,
    MODDATE       T_DATE /* T_DATE = DATE NOT NULL */,
    INSDATE       T_DATE /* T_DATE = DATE NOT NULL */
)^

ALTER TABLE OPRETGROUP_HEAD ADD CONSTRAINT PK_OPRETGROUP_HEAD PRIMARY KEY (ID)^

CREATE OR ALTER TRIGGER OPRETGROUP_HEAD_BI FOR OPRETGROUP_HEAD
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  new.insdate = 'now';
  new.moddate = 'now';
end^


CREATE OR ALTER TRIGGER OPRETGROUP_HEAD_BU FOR OPRETGROUP_HEAD
ACTIVE BEFORE UPDATE POSITION 0
as
begin
  if (old.id <> new.id) then begin
    new.insdate = 'now';
    new.moddate = 'now';
  end
  if (old.name <> new.name or
      old.comment is null and new.comment is not null or
      old.comment is not null and new.comment is null or
      old.comment <> new.comment)
    then new.moddate = 'now';
end^


COMMENT ON TABLE OPRETGROUP_HEAD IS
'  '^

COMMENT ON COLUMN SUPERPLACE_HEAD.ID IS 
'   '^

COMMENT ON COLUMN SUPERPLACE_HEAD.NAME IS
' '^

COMMENT ON COLUMN SUPERPLACE_HEAD.COMMENT IS 
''^

COMMENT ON COLUMN SUPERPLACE_HEAD.MODDATE IS 
'  '^

COMMENT ON COLUMN SUPERPLACE_HEAD.INSDATE IS 
'  '^

GRANT SELECT, INSERT, UPDATE, DELETE ON OPRETGROUP_HEAD TO PUBLIC^

CREATE TABLE OPRETGROUP (
    ID              T_ID /* T_ID = INTEGER NOT NULL */,
    OPERATION       t_operation NOT NULL,
    SUPERPLACE      T_ID NOT NULL /* T_ID = INTEGER NOT NULL */,
    COMMENT         T_COMMENT COLLATE PXW_CYRL /* T_COMMENT = VARCHAR(255) */,
    MODDATE         T_DATE /* T_DATE = DATE NOT NULL */,
    INSDATE         T_DATE /* T_DATE = DATE NOT NULL */
)^

ALTER TABLE OPRETGROUP ADD CONSTRAINT PK_OPRETGROUP PRIMARY KEY (ID, OPERATION)^

ALTER TABLE OPRETGROUP ADD CONSTRAINT FK_OPRETGROUP_HEAD FOREIGN KEY (ID) REFERENCES OPRETGROUP_HEAD (ID) ON DELETE CASCADE ON UPDATE CASCADE^

ALTER TABLE OPRETGROUP ADD CONSTRAINT FK_OPRETGROUP_OPER FOREIGN KEY (OPERATION) REFERENCES operations (ID_OPERATION) ON DELETE CASCADE ON UPDATE CASCADE^

ALTER TABLE OPRETGROUP ADD CONSTRAINT FK_OPRETGROUP_SUP FOREIGN KEY (SUPERPLACE) REFERENCES SUPERPLACE_HEAD (ID) ON DELETE CASCADE ON UPDATE CASCADE^

CREATE INDEX OPRETGROUP_IDX ON OPRETGROUP (OPERATION, SUPERPLACE)^

CREATE OR ALTER TRIGGER OPRETGROUP_BI FOR OPRETGROUP
ACTIVE BEFORE INSERT POSITION 0
as
declare variable v_i integer;
begin
  if (exists(select 1 from OPRETGROUP where operation=new.operation and id=new.id)) then
      exception e_opretgroup_two_same;
  new.insdate='now'; new.moddate='now';
end^


/* Trigger: SUPERPLACE_BU */
CREATE OR ALTER TRIGGER OPRETGROUP_BU FOR OPRETGROUP
ACTIVE BEFORE UPDATE POSITION 0
as
declare variable v_i integer;
begin
  if (old.operation<>new.operation or old.superplace<>new.superplace or
      (old.comment is null and new.comment is not null or
       old.comment is not null and new.comment is null or
       old.comment<>new.comment)) then begin
    new.moddate='now';
  end
end^

COMMENT ON TABLE OPRETGROUP IS
'   '^

COMMENT ON COLUMN OPRETGROUP.ID IS
'   '^

COMMENT ON COLUMN OPRETGROUP.OPERATION IS
'  '^

COMMENT ON COLUMN OPRETGROUP.SUPERPLACE IS
'      '^

COMMENT ON COLUMN OPRETGROUP.COMMENT IS
''^

COMMENT ON COLUMN OPRETGROUP.MODDATE IS
'  '^

COMMENT ON COLUMN OPRETGROUP.INSDATE IS
'  '^


GRANT SELECT, INSERT, UPDATE, DELETE ON OPRETGROUP TO PUBLIC^

insert into CONFIG (PARAMNAME, SECTION, PARAMTYPE, BOOLPARAM, COMMENT)
     select 'UseOpRetGroup', 16, 3, 'F', '   '
       from RDB$DATABASE
      where not exists(select 1 from CONFIG where PARAMNAME = 'UseOpRetGroup')^

insert into SMREFERENCES (ID, NAME, PROGMOD_CLASS, IS_USE, IN_REF_MENU)
     values (140, '  ', 'V_OPRETGROUP', 'F', 'T')^

CREATE OR ALTER TRIGGER CONFIG_AU FOR CONFIG
ACTIVE AFTER UPDATE POSITION 0
as
declare variable v_old integer;
declare variable v_new integer;
declare variable tmp_b char;
declare variable tmp_b1 char;
declare variable tmp_b2 char;
declare variable art_len integer;
declare variable prf_len integer;
begin
  --       ..       (    )

  -- CashLockByFilial           XCASH_SESSION_CORRECT

  if (new.paramname = 'UseConsignee') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where fieldname = 'CONSIGNEE';
  end else
  if (new.paramname = 'UseConsignor') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where fieldname = 'CONSIGNOR';
  end else
  if (new.paramname = 'DocTrReadOnly') then begin
    v_old = 0; if (old.boolparam = 'T') then v_old = 1;
    v_new = 0; if (new.boolparam = 'T') then v_new = 1;
    if (v_old = 0 and v_new = 1) then begin
    --    'DocTrReadOnly'
    --      'SpecAutoCommit'
      update CONFIG set boolparam = 'T' where paramname = 'SpecAutoCommit';
    end
  end else
  if (new.paramname = 'ExtCardParam') then begin
    --      -      
    if (new.strparam <> old.strparam) then begin
      update MULTIEDIT_FIELDS set name = new.strparam where kind = 0 and fieldname = 'EXTPARAM';
      update MULTIEDIT_GRIDFIELDS set field_caption = new.strparam where id = 56;
      if (new.strparam <> '')
        then update SMREFERENCES set is_use = 'T', name = new.strparam where id = 61;
        else update SMREFERENCES set is_use = 'F', name = '     ' where id = 61;
    end
  end else
  -- SM-2622   
  if (new.paramname='UseDeniedWriteoffOperations') then begin
      update smreferences set is_use = new.boolparam where id = 139;
  end -- SM-2622
  if (new.paramname = 'UseCardABC') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'ABC';
  end else
  if (new.paramname = 'UseCardClientTaxes') then begin
     update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDCLIENTTAX';
  end else
  if (new.paramname = 'UseCardCategor') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CATEGOR';
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 35;
  end else
  if (new.paramname = 'UseCardLockPrice') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'LOCKPRICE';
  end else
  if (new.paramname = 'UseCardMesurim') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'MESURIM';
  end else
  if (new.paramname = 'UseCardPermisInterface') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'PERMISSION';
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 46;
  end else
  if (new.paramname = 'UseCardXYZ') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'XYZ';
  end else
  if (new.paramname = 'OVSUseForClients' and new.boolparam='F') then begin
    if ((select count(o.id) from ovs_stage o where o.is_use=1 and o.ovs_kind=0)>1) then
      update ovs_stage o set o.is_use=0 where o.ovs_kind=0;
    if ((select count(o.id) from ovs_stage o where o.is_use=1 and o.ovs_kind=7)>1) then
      update ovs_stage o set o.is_use=0 where o.ovs_kind=7;
  end else
  if (new.paramname = 'UseSertif') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'SERTIF';
    --  
    update SMREFERENCES set is_use = new.boolparam where id = 47;
  end else
  if (new.paramname = 'UseTovar') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'TOVAR';
    --   , 
    update SMREFERENCES set is_use = new.boolparam where id in (22, 33);
  end else
  if (new.paramname = 'UseAlko') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'VID';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'SPIRT';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'IS_OLD_EXCISE';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'IS_ALCO';     -- SM-1762
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 60;
  end else
  if (new.paramname = 'UseVcbClSfera') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 45;
  end else
  if (new.paramname = 'UseMetro') then begin
    --    METRO
    update SMREFERENCES set is_use = new.boolparam where id = 130;
  end else
  if (new.paramname = 'UseCurrency') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CUR_TYPE';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'PRICECUR';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'PRICERUB';
    --     
    update SMREFERENCES set is_use = new.boolparam where id = 7 or id = 8;
  end else
  if (new.paramname = 'UseCardSections') then begin
    --   
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDSECTIONS';
  end else
  if (new.paramname = 'UseTimePlanPost') then begin
    --     
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 3 and fieldname = 'USE_TIME_PLAN_POST';
  end else
  if (new.paramname = 'UseCardColorLighting') then begin
    --  
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDCOLORLIGHTING';
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'COLORLIGTING';
    --  
    select boolparam from CONFIG where paramname = 'UseColor' into tmp_b;
    if (tmp_b = 'F' and new.boolparam = 'F') then tmp_b = 'F'; else tmp_b = 'T';
    update SMREFERENCES set is_use = :tmp_b where id = 34;
  end else
  if (new.paramname = 'UseCardManager') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'MANAGERS';
  end else
  if (new.paramname = 'UseInOrder') then begin
    --      
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 3 and fieldname = 'CLIENT_INORDER';
  end else
  if (new.paramname = 'UseCardClients') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDCLIENTS';
  end else
  if (new.paramname = 'UseCardOrderKind') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'ORDERKIND';
  end else
  if (new.paramname = 'UseZapas') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'ZAPAS';
  end else
  if (new.paramname = 'UseCardCashPlace') then begin
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CASHPLACE';
  end else
  if (new.paramname = 'CashLoadUseDiscLimByMargin') then begin
    update MULTIEDIT_GRIDFIELDS set is_used = new.boolparam where id = 146;
  end else
  if (new.paramname = 'UseNLoss') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 16;
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDNLOSS';
  end  else
  if (new.paramname = 'UseMaterial') then begin
    --   ,  , 
    update SMREFERENCES set is_use = new.boolparam where id in (25, 26, 28);
  end else
  if (new.paramname = 'UseRzScale') then begin
    --  
    update SMREFERENCES set is_use = new.boolparam where id = 31;
  end else
  if (new.paramname = 'UseColor') then begin
    --  
    select boolparam from CONFIG where paramname = 'UseCardColorLighting' into tmp_b;
    if (tmp_b = 'F' and new.boolparam = 'F') then tmp_b = 'F'; else tmp_b = 'T';
    update SMREFERENCES set is_use = :tmp_b where id = 34;
  end else
  if (new.paramname = 'UseCustomer') then begin
    --   , 
    update SMREFERENCES set is_use = new.boolparam where id in (18, 19);
  end else
  if (new.paramname = 'UseSuperPlace') then begin
    --    
    update SMREFERENCES set is_use = new.boolparam where id = 36;
  end else
  if (new.paramname = 'UseSuperFilial') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 38;
  end else
  if (new.paramname = 'UseSuperCash') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 43;
  end else
  if (new.paramname = 'UseFirm') then begin
    --  
    update SMREFERENCES set is_use = new.boolparam where id = 37;
  end else
  if (new.paramname = 'UseCardNumber') then begin
    --    ()
    update SMREFERENCES set is_use = new.boolparam where id = 39;
  end else
  if (new.paramname = 'UsePriceGroup') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 42;
  end else
  if (new.paramname = 'UseVcbOwnKind') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 44;
  end else
  if (new.paramname = 'UseSuperPermission') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 56;
  end else
  if (new.paramname = 'UseOpRetGroup') then begin
    --    
    update SMREFERENCES set is_use = new.boolparam where id = 140;
  end else
  if (new.paramname = 'CardClassifQuota') then begin
     update SMREFERENCES set is_use = new.boolparam where id = 58;
  end else
  if (new.paramname = 'CardMainParamView') then begin
    if (new.numparam = 1) then
    -- CardMainParamView -     : 0-; 1-1
    --    1   :
    --    ,  ABC,  XYZ,  , ,  -  
    --        ABC/XYZ , 
    --       
      update CONFIG set boolparam = 'F' where paramname = 'GrABCInCardRequired';
      update CONFIG set boolparam = 'F' where paramname = 'GrXYZInCardRequired';
  end else
  if (new.paramname = 'UsePartspec') then begin
    v_old = 0; if (old.boolparam = 'T') then v_old = 1;
    v_new = 0; if (new.boolparam = 'T') then v_new = 1;
    if (v_old = 1 and v_new = 0) then begin
    --    'UsePartspec'
    --       'PartspecBad'
      update CONFIG set boolparam = 'T' where paramname = 'PartspecBad';
    end
  end else
  if (new.paramname = 'UseCardWriteOff') then begin --  
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'WRITEOFF';
  end else
  if (new.paramname = 'UseCardTurnPlace') then begin --  
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'TURNPLACE';
  end else
  if (new.paramname = 'UseCardOrderLock') then begin --  
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'ORDER_LOCK';
  end else
  if (new.paramname = 'UseCardHEH') then begin
    update SMREFERENCES set is_use = new.boolparam where id = 129;
  end else
  if (new.paramname = 'UseMarking') then begin -- 
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'MARKING';
  end else
  if (new.paramname = 'UseClientExchange') then begin --   ()
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 3 and fieldname = 'EMAIL_DATA';
  end else
  if (new.paramname = 'UsePlaceIdlePeriod') then begin --   ()
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 6 and fieldname = 'IDLE_PERIODS';
  end else
  if (new.paramname = 'UseCashPrintGroups') then begin
    --   
    update SMREFERENCES set is_use = new.boolparam where id = 137;
    --    
    update MULTIEDIT_FIELDS set is_use = new.boolparam where kind = 0 and fieldname = 'CARDCASHPRINTGROUP';
  end else
  if (new.paramname = 'OVSUseForClients') then begin
    select boolparam from CONFIG where paramname = 'UseOVS' into tmp_b;
    if (tmp_b = 'T' and new.boolparam = 'T') then tmp_b = 'T'; else tmp_b = 'F';
    --      
    update MULTIEDIT_FIELDS set is_use = :tmp_b where kind = 3 and fieldname = 'OVS';
  end else
  if (new.paramname = 'UseOVS') then begin
    select boolparam from CONFIG where paramname = 'OVSUseForClients' into tmp_b;
    if (tmp_b = 'T' and new.boolparam = 'T') then tmp_b = 'T'; else tmp_b = 'F';
    --      
    update MULTIEDIT_FIELDS set is_use = :tmp_b where kind = 3 and fieldname = 'OVS';
  end else
  if (new.paramname = 'GenArtLength' or new.paramname = 'GenArtPrefix') then begin
    if (new.paramname = 'GenArtLength')
      then art_len = new.numparam;
      else select numparam from CONFIG where paramname = 'GenArtLength' into :art_len;
    if (new.paramname = 'GenArtPrefix')
      then prf_len = char_length(new.strparam);
      else select char_length(strparam) from CONFIG where paramname = 'GenArtPrefix' into :prf_len;
    if ((art_len + prf_len) > 30) then  exception e_len_art_prefix_error;
  end else
  if (new.paramname = 'UseRoutesLists' or new.paramname = 'UseRoute') then begin
    if (new.paramname = 'UseRoutesLists') then begin
      tmp_b1 = new.boolparam;
      update SMREFERENCES set is_use = new.boolparam where id = 133;   --  ""
      update SMREFERENCES set is_use = new.boolparam where id = 134;   --  " "
      update SMREFERENCES set is_use = new.boolparam where id = 135;   --  " "
      update SMREFERENCES set is_use = new.boolparam where id = 136;   --  " "
    end else select boolparam from CONFIG where paramname = 'UseRoutesLists' into tmp_b1;
    if (new.paramname = 'UseRoute')
      then tmp_b2 = new.boolparam;
      else select boolparam from CONFIG where paramname = 'UseRoute' into tmp_b2;
    if (tmp_b1 = 'T' or tmp_b2 = 'T') then tmp_b = 'T'; else tmp_b = 'F';
    update SMREFERENCES set is_use = :tmp_b where id = 88;    --  
  end
end^

CREATE OR ALTER TRIGGER OPERATIONS_AU FOR OPERATIONS
ACTIVE AFTER UPDATE POSITION 0
as
begin
  if (new.id_operation <> old.id_operation)
    then update DOCHEAD set operation = new.id_operation  where operation = old.id_operation;
  --   opretgroup             au   new
  if (new.opertype <> 1 and old.opertype = 1) then
    delete from opretgroup op where op.operation = new.id_operation;
end^

CREATE OR ALTER TRIGGER SUPERPLACE_HEAD_AU FOR SUPERPLACE_HEAD
ACTIVE AFTER UPDATE POSITION 0
AS
begin
  if (new.spkind <> old.spkind) then begin
    if (old.spkind = 13) then
      delete from opretgroup op where op.superplace = new.id;
    update SUPERPLACE set spkind = new.spkind where id = new.id;
    delete from SEL_SUPERPLACE where sp_index = new.id;
  end
  if (new.is_used <> old.is_used) then begin
    update SUPERPLACE set sp_is_used = new.is_used where id = new.id;
    if (new.is_used = 'F') then delete from SEL_SUPERPLACE where sp_index = new.id;
  end
end^

create or alter procedure AXAPTA_EXPDOCLINE (
    DOCHEADERID T_FID,
    ITEMID T_ARTICUL_NULL,
    UNITID T_INT_VALUE,
    QTY T_QUANTITY_NULL,
    PRICE T_MONEY_NULL,
    DISCAMOUNT T_MONEY_NULL,
    DISCPERCENT T_MONEY_NULL,
    AMOUNT T_MONEY_NULL,
    TAXCODE T_INT_VALUE,
    TAXVALUE T_INT_VALUE,
    TAXAMOUNT T_MONEY_NULL,
    GTD T_CUSTOM,
    CONTRAGENTID T_FID,
    STAGE_ID T_FID)
returns (
    ERR T_STRING100_NULL)
as
declare variable v_qty t_quantity_null;
declare variable v_price t_money_null;
declare variable v_accept t_char;
begin
  UnitId =  coalesce(UnitId, -2);
  Qty =  coalesce(Qty, 0);
  Price = coalesce(Price, 0);
  taxcode = coalesce(taxcode, -1);
  taxamount = coalesce(taxamount, 0);
  if (taxcode = 0) then taxcode = -1;
  select accept from DOCHEAD where id_dochead = :docheaderid into :v_accept;
  if (v_accept is null) then begin
    err = '   ';
    suspend;
    exit;
  end
  if (v_accept = 'T') then begin
    err = '  ';
    suspend;
    exit;
  end
  if (not taxcode in (-1,1,5,7,8)) then begin
    err = ' Taxcode     (0,1,5,7,8)';
    suspend;
    exit;
  end
  if (trim(coalesce(ItemId, '')) = '')
    then err = '  ItemId';
    else begin
      if (not exists(select 1 from CARDSCLA cc where cc.articul = :itemid))
        then err = '  ItemId';
    end
  if (trim(coalesce(UnitId, '')) = '')
    then err = '  UnitId';
    else begin
      if (not exists(select 1 from MESURIMENT cc where cc.id_mesuriment = :UnitId))
        then err = '  UnitId';
    end

  if (err is null) then begin
    execute procedure SPEC_ADD(:DocHeaderId, :ItemId, :UnitId, 0, :Qty, :Price, 0);
    update DOCSPEC set taxhead = :TaxCode where id_dochead = :DocHeaderId and articul = :ItemId;
    update DOCSPEC set nds = :TaxAmount where id_dochead = :DocHeaderId and articul = :ItemId;
    if (exists(select 1 from DOCSPEC_OVS dov where dov.dochead = :docheaderid and dov.articul = :itemid)) then begin
      select dov.q_ot_vs, dov.price_ot_vs
        from DOCSPEC_OVS dov where dov.dochead = :docheaderid and dov.articul = :itemid
        rows 1
      into :v_qty, :v_price;
      if(v_qty + qty > 0.00001)
        then v_price = (v_qty * v_price + qty * price) / (v_qty + qty);
        else v_price = (v_price + price) / 2;
      v_qty = qty + v_qty;
      update DOCSPEC_OVS set q_ot_vs = :v_qty, price_ot_vs = :v_price where dochead = :docheaderid and articul = :itemid;
    end else
      insert into DOCSPEC_OVS(dochead, articul, asrt, ovs_id, q_ot_vs, price_ot_vs)
        values(:DocHeaderId, :itemid, 0, :stage_id, :qty,:price);
  end
  suspend;
end^

create or alter procedure AXAPTA_IMPDOCHEADER_TRACEERR (
  STAGE_ID T_FID)
returns (
  ERR T_COMMENT)
AS
declare variable docheaderid t_fid;
begin
  for select dh.id_dochead
    from DOCHEAD_OVS dov
    inner join DOCHEAD dh on dh.id_dochead = dov.dochead and dh.accept = 'T'
    left join OVS_AXAPTA ova on ova.ovs_id = dov.ovs_kind and ova.doctype_id = dh.doctype and ova.operation_id = dh.operation
    left join AXAPTA_DOCFLOW adf on adf.is_import = 0 and adf.docflowid = ova.docflow_id
    left join DOCHEAD_PARAMS dp on dp.dochead = dh.id_dochead
    where dov.ovs_kind = :stage_id and dov.post_status = 20 and
          ((ova.ovs_id is not null and adf.docflowid is not null) or (dh.doctype in (1000,1001)))
    into :DocHeaderId
  do begin
    if (exists(select 1
                 from DOCHEAD dh
                 inner join OPERATIONS oper on oper.id_operation = dh.operation and oper.is_package = 1
                 inner join DOCSPEC ds on ds.id_dochead = dh.id_dochead
                 inner join CARDSCLA cc on cc.articul = ds.articul
                 inner join CARDTYPES cts on cts.id_cardtype = cc.cardtype and cts.cardkind <> 2
                 where dh.id_dochead = :DocHeaderId)) then begin
      err = '   ' || :docheaderid || '     ';
      suspend;
    end
  end
end^

ALTER TABLE CLIENTS
ADD OPRETGROUP T_FID^

CREATE INDEX OPRETGROUP_HEAD_IDXNAME
ON OPRETGROUP_HEAD (NAME)^

create or alter procedure AXAPTA_CONTRAGENTRETURNGROUP (
    RETURNGROUPID T_FID,
    NAME t_full_name_null)
returns (
    ERR T_STRING100_NULL)
AS
  declare variable v_name t_name_null;
begin
  name = trim(coalesce(name, ''));
  if (char_length(name) > 40) then
    v_name = left(name, 40);
  else
    v_name = name;
  if (v_name='') then
      err = '  Name';
  else
  begin
    if (exists(select 1 from opretgroup_head c where c.name=:v_name and c.id<>:returngroupid)) then
        err = '   Name  ';
  end
  if (err is null) then
    update or insert into opretgroup_head(ID,NAME) values(:returngroupid,:v_name);
  suspend;
end^

grant execute on procedure AXAPTA_CONTRAGENTRETURNGROUP to public^

create or alter procedure AXAPTA_CONTRAGENTRETURNGROUPL (
    ReturnGroupId  t_fid, 
    OperationTypeId t_fid,
    GroupLocationId t_fid
)
returns (
    ERR T_STRING100_NULL)
AS
begin
  if (not exists(select 1 from opretgroup_head p where p.id=:returngroupid)) then
    err = '   ReturnGroupId';
  if (not exists(select 1 from Operations p where p.id_operation = :OperationTypeId and p.opertype = 1)) then
  begin
    if (err is null) then
      err = '   OperationTypeId';
    else
      err = err || ',    OperationTypeId';
  end
  if (not exists(select 1 from superplace_head p where p.id = :GroupLocationId and p.spkind = 13)) then
  begin
    if (err is null) then
      err = '   GroupLocationId';
    else
      err = err || ',    GroupLocationId';
  end
  if (err is null) then
    update or insert into opretgroup(ID, OPERATION, SUPERPLACE) values(:ReturnGroupId, :OperationTypeId, :GroupLocationId);
  suspend;
end^

grant execute on procedure AXAPTA_CONTRAGENTRETURNGROUPL to public^

create or alter procedure AXAPTA_CUSTVENDTABLE (
    CONTRAGENTID T_FID,
    INN T_INN,
    CONTRAGENTNUM T_STR20,
    NAME T_FULL_NAME_NULL,
    CITY T_INT_VALUE,
    ADDRES T_STR_VALUE,
    KPP T_KPP,
    SEGMENTID T_FID,
    EDIACTIVE T_INT_VALUE,
    RETURNGROUPID T_FID)
returns (
    ERR T_STRING100_NULL)
AS
declare variable v_id_clients t_fid;
declare variable err_ T_STR4096;
begin
  if (city = 0) then
    city = null;
  EDIActive = coalesce(EDIActive, 0);
  if (ContragentId is null) then err_ = '  ContragentId';
  if (trim(coalesce(name, '')) = '')
    then if (err_ is null)
           then err_ = '  Name';
           else err_ = err_ || ',   Name';
  if (SegmentId is null)
    then if (err_ is null)
           then err_ = '  SegmentId';
           else err_ = err_ || ',   SegmentId';
  if (city <> 0 and
      not exists(select 1 from CITY where id_city = :city))
    then if (err_ is null)
           then err_ = '   SM(City)';
           else err_ = err_ || ',    SM(City)';
  if (segmentid is not null and
      not exists(select 1 from CLASSIF where id_classif = :segmentid))
    then if (err_ is null)
           then err_ = ' segmentid';
           else err_ = err || ',  segmentid';
  if (coalesce(RETURNGROUPID,0)<>0) then
    if (not exists(select 1 from opretgroup_head op where op.id=:RETURNGROUPID)) then if (err_ is null)
           then err_ = ' RETURNGROUPID';
           else err_ = err || ',  RETURNGROUPID';
  if (char_length(err_) >= 100) then
    err = left(ERR_, 95) || '...';
  else
    err = err_;
  if (err is null) then begin
    update or insert into CLIENTS(client_type, id_clients, inn_clients, ident_clients, name_clients,
                                  city_clients, addres_clients, kpp, classif, is_juridical, opretgroup)
      values(0, :contragentid, :inn, :contragentnum, :name,
             :city, :addres, :kpp, :segmentid, 'T', iif(:RETURNGROUPID=0,null,:RETURNGROUPID))
      returning id_clients into :v_id_clients;
    update or insert into CLIENT_SMREF_ADD(id_clients, kind, id, num_value)
      values(:v_id_clients, 64, -1, iif(:EDIActive > 0, 1, 0));
  end
  suspend;
end^

create or alter procedure ACT_OPRET_GET_O(
  ID_DOCHEAD T_FID)
returns(
  operation T_FID)
as
  declare variable v_opretgroup integer;
  declare variable v_client2 integer;
begin
  if (exists(select 1 from dochead dh left join operations op on op.id_operation=dh.operation where dh.id_dochead= :ID_DOCHEAD and op.opertype=1)) then begin
    select c.opretgroup, dh.client2_index from dochead dh left join clients c on c.id_clients= dh.client_index where dh.id_dochead= :ID_DOCHEAD into :v_opretgroup, :v_client2;
    if (v_opretgroup is not NULL) then
      select op.operation from opretgroup op left join superplace s on s.id= op.superplace where op.id = :v_opretgroup and s.placeindex= :v_client2 rows 1 into :operation;
  end
  suspend;
end^

grant execute on procedure ACT_OPRET_GET_O to public^

create or alter procedure ACT_WRITEOFF_DONE (
    V_ACTHEAD T_DOC,
    V_DOCTYPE T_FID,
    V_OPERATION T_FID,
    V_LOCK_OPERATION t_int_boolean_null default 0)
AS
declare variable v_actindex t_doc_index;
declare variable v_dochead integer;
declare variable v_shopindex integer;
declare variable v_filialindex integer;
declare variable v_docindex t_doc_index;
declare variable v_doc_date date;
declare variable v_ext_doctype integer;
declare variable v_ext_docindex t_ext_doc_index;
declare variable v_ext_doc_date date;
declare variable v_client_index integer;
declare variable v_client2_index integer;
declare variable v_client_bank integer;
declare variable v_client2_bank integer;
declare variable v_cur_type t_cur_type;
declare variable v_curs double precision;
declare variable v_manager integer;
declare variable v_indochead integer;
declare variable v_chr integer;
declare variable v_articul t_articul_null;
declare variable v_asrt integer;
declare variable v_pos_number integer;
declare variable v_mesuriment integer;
declare variable v_quantity double precision;
declare variable v_pricerub double precision;
declare variable v_pricecur double precision;
declare variable v_pricerub1 double precision;
declare variable v_pricecur1 double precision;
declare variable v_taxhead integer;
declare variable v_barcode t_barcode_null;
declare variable v_comment t_comment;
declare variable v_spec_quantity double precision;
declare variable v_rz integer;
declare variable v_act_opertype integer;
declare variable v_doc_pack integer;
declare variable v_doc_asrt integer;
declare variable v_a integer;
declare variable v_p integer;
declare variable is_neust integer;
declare variable v_dochead_comment t_comment;
declare variable v_lp integer;
declare variable v_cfu integer;
declare variable v_activity_kind integer;
declare variable num_tn t_num_tn;
declare variable date_tn date;
declare variable v_maxminavg integer;
declare variable consignee integer;
declare variable consignor integer;
declare variable phys_address smallint;
declare variable phys_address1 smallint;
declare variable v_dt integer;
declare variable v_df integer;
declare variable v_op integer;
declare variable v_ci integer;
declare variable v_os_stage integer;
declare variable v_country integer;
declare variable v_art t_articul_null;
declare variable v_custom t_custom;
begin

  --   
  --  ,  
  --     (   tmp_writeoff)
  --       

  --          ,   
  delete from TMP_WRITEOFF where acthead = :v_acthead and (cmp_dbl_e(quantity, 0) < 1 or indochead = -1); --  quantity<=0

  --   
  execute procedure ACT_CORRECT_PRICE(:v_acthead);

  --     
  select cf.numparam from CONFIG cf where cf.paramname = 'OutMovePartspec' into :v_maxminavg;

  --     
  select dh.docindex, dh.shopindex, dh.dochead_filialindex, dh.doc_date,
         dh.client_index, dh.client2_index, dh.client_bank,
         dh.client2_bank, dh.cur_type, dh.curs, dh.manager, dh.comment,
         dh.ext_doctype, dh.ext_docindex, dh.ext_doc_date, op.opertype, legal_person
    from DOCHEAD dh
    left join OPERATIONS op on op.id_operation = dh.operation
    where id_dochead = :v_acthead
  into :v_actindex, :v_shopindex, :v_filialindex, :v_doc_date,
       :v_client_index, :v_client2_index, :v_client_bank,
       :v_client2_bank, :v_cur_type, :v_curs, :v_manager, :v_dochead_comment,
       :v_ext_doctype, :v_ext_docindex, :v_ext_doc_date, :v_act_opertype, :v_lp;

  select cfu, activity_kind, num_tn, date_tn, consignee, consignor, phys_address, phys_address1
    from DOCHEAD_PARAMS where dochead = :v_acthead
  into :v_cfu, :v_activity_kind, :num_tn, :date_tn, :consignee, :consignor, :phys_address, :phys_address1;

  --     , ..     10 
  if (char_length(v_actindex) >= 10) then begin
    exception E_LENGHT_DOCINDEX;
    exit;
  end
  if (v_client_index is null) then v_client_index = -1; --   v_client_index   ,       

  --      
  is_neust = 0;
  for select ds.articul, ds.rz, ds.mesuriment, ds.quantity, ds.pricerub, ds.pricecur
    from DOCSPEC ds
    left join CARDSCLA cs on ds.articul = cs.articul
    left join CARDTYPES ct on cs.cardtype = ct.id_cardtype
    where ds.id_dochead = :v_acthead and ct.is_matirial = 'T'
    into :v_articul, :v_rz, :v_mesuriment, :v_quantity, :v_pricerub, :v_pricecur
  do for select a.asrt, a.quantity - lq.quantity
       from VW_ASRT_DOCSPEC(:v_acthead, :v_articul, :v_rz, :v_mesuriment, :v_quantity) a
       left join ACT_LINK_QUANTITY(:v_acthead, :v_articul, a.asrt) lq on 1=1
       into :v_asrt, :v_quantity
     do if (cmp_dbl_e(v_quantity, 0) = 1) then begin --  v_quantity>0
          --       tmp_writeoff
          insert into TMP_WRITEOFF(acthead, articul, asrt, outdochead, indochead, quantity, pricerub, pricecur)
            values(:v_acthead, :v_articul, :v_asrt, -1, -1, :v_quantity, :v_pricerub, :v_pricecur);
          is_neust = 1;
        end

  --        tmp_writeoff    
  --  act_link_quantity    

  --     (     ,      )
  if (v_act_opertype = 1 and is_neust = 1 or                 --      
      v_act_opertype = 3 and v_client_index = -1) then begin --       
    delete from TMP_WRITEOFF where acthead = :v_acthead and indochead = -1;
    exception ACCESS_DENIED_EXCEPTION;
  end

  v_dochead = -1; v_chr = 96; -- 96 = Ord('a') - 1
  --         tmp_writeoff
  for select distinct indochead --        
    from TMP_WRITEOFF
    where acthead = :v_acthead and indochead <> -1
    into :v_indochead
  do begin
    --      ,    , ..       
    --      -     
    if (v_act_opertype = 1)
      then select client_index, client_bank from DOCHEAD where id_dochead = :v_indochead into :v_client_index, :v_client_bank;

    --   
    v_dochead = gen_id(dochead_gen, 1);
    v_a = 0;
    while (v_a = 0) do begin
      v_chr = v_chr + 1;
      if (v_chr < 123)
        then v_docindex = ascii_char(v_chr);
        else v_docindex = ascii_char(96 + div(v_chr, 122)) || ascii_char(96 + mod(v_chr, 122));
      --     , ..     10 
      if (char_length(v_actindex || v_docindex) > 10) then begin
        exception E_LENGHT_DOCINDEX;
        exit;
      end else v_docindex = v_actindex || v_docindex;
      if (not exists(select 1 from DOCHEAD where shopindex = :v_shopindex and doctype = :v_doctype and docindex = :v_docindex))
        then v_a = 1;
    end

    insert into DOCHEAD(id_dochead, shopindex, dochead_filialindex, doctype, docindex, doc_date, client_index,
                        client2_index, client_bank, client2_bank, operation, cur_type, curs, doc_state,
                        manager, comment, ext_doctype, ext_docindex, ext_doc_date, legal_person)
      values (:v_dochead, :v_shopindex, :v_filialindex, :v_doctype, :v_docindex, :v_doc_date, :v_client_index,
              :v_client2_index, :v_client_bank, :v_client2_bank, :v_operation, :v_cur_type, :v_curs, -1, -- doc_state=-1 -   
              :v_manager, :v_dochead_comment, :v_ext_doctype, :v_ext_docindex, :v_ext_doc_date, :v_lp);
    update DOCHEAD_PARAMS
      set cfu = :v_cfu, activity_kind = :v_activity_kind, num_tn = :num_tn, date_tn = :date_tn,
          consignee = :consignee, consignor = :consignor,
          phys_address = :phys_address, phys_address1 = :phys_address1, lock_ret_oper = :V_LOCK_OPERATION
    where dochead = :v_dochead;

    if (exists (select 1 from DOCHEAD_TRANSPORT where dochead = :v_acthead))
      then insert into DOCHEAD_TRANSPORT (dochead, committee1, committee2, collector1, collector2, inspector1, inspector2)
             select :v_dochead, committee1, committee2, collector1, collector2, inspector1, inspector2
               from DOCHEAD_TRANSPORT where dochead = :v_acthead;

    insert into DOCHEAD_LINK(dochead, basedochead) values(:v_dochead, :v_acthead);  --   
    insert into DOCHEAD_FIX(dochead, basedochead, kind) values(:v_dochead, :v_indochead, 2); --    

    v_pos_number = 1;

    --  
    for select articul, sum(quantity), iif(:v_maxminavg = 2, sum(pricerub * quantity), iif(:v_maxminavg = 0, max(pricerub), min(pricerub))),
               iif(:v_maxminavg = 2, sum(pricecur * quantity), iif(:v_maxminavg = 0, max(pricecur), min(pricecur)))
      from TMP_WRITEOFF
      where acthead = :v_acthead and indochead = :v_indochead
      group by articul
      into :v_articul, :v_quantity, :v_pricerub, :v_pricecur
    do begin
      --  v_pricerub  v_pricecur   -     
      if (v_maxminavg = 2) then begin
        v_pricerub = v_pricerub / v_quantity; v_pricecur = v_pricecur / v_quantity;
      end

      select mesuriment, rz, barcode, comment, quantity, pricerub_1, pricecur_1 --     (    )
        from DOCSPEC where id_dochead = :v_acthead and articul = :v_articul     --   
      into :v_mesuriment, :v_rz, :v_barcode, :v_comment, :v_spec_quantity, :v_pricerub1, :v_pricecur1;
      if (v_spec_quantity is null) then v_spec_quantity = 0;

      if (cmp_dbl_e(v_spec_quantity, 0) = 1) then begin --  v_spec_quantity>0

        select taxhead from DOCSPEC                                         --    
          where id_dochead = :v_indochead and articul = :v_articul
        into :v_taxhead;

        v_doc_pack = v_mesuriment; v_doc_asrt = v_rz; --      
        if (v_rz = -1) then begin
          --         ,
          --           (   )
          v_a = null; v_p = null;
          select count(distinct t.asrt), min(t.asrt), count(distinct s.mesuriment), min(s.mesuriment)
            from TMP_WRITEOFF t
            inner join DOCSPECEXT s on t.acthead = s.dochead and t.articul = s.articul and t.asrt = s.rz
            where t.acthead = :v_acthead and t.indochead = :v_indochead and t.articul = :v_articul
          into :v_a, :v_doc_asrt, :v_p, :v_doc_pack; -- v_i>0  v_p>0    
          if (v_a > 1) then v_doc_asrt = -1; if (v_p > 1) then v_doc_pack = -1;
        end

        --      ,
        --     ,    docspec_bi   (quantity  pack_quantity)
        insert into DOCSPEC(id_dochead, articul, pos_number, mesuriment, rz,
                            quantity, pricerub, pricecur, pricerub_1, pricecur_1, taxhead, barcode, comment)
          values (:v_dochead, :v_articul, :v_pos_number, :v_doc_pack, :v_doc_asrt,
                  :v_quantity, :v_pricerub, :v_pricecur, :v_pricerub1, :v_pricecur1, :v_taxhead, :v_barcode, :v_comment);
        v_pos_number = v_pos_number + 1;

        if (v_doc_pack = -1 or v_doc_asrt = -1) then begin
          --       
          for select asrt, sum(quantity)
            from TMP_WRITEOFF
            where acthead = :v_acthead and indochead = :v_indochead and articul = :v_articul
            group by asrt
            into :v_asrt, :v_quantity
          do begin
            select quantity from VW_ASRT_DOCSPEC(:v_acthead, :v_articul, :v_asrt, null, null) into :v_spec_quantity;
            if (cmp_dbl_e(v_quantity, 0) = 1 and cmp_dbl_e(v_spec_quantity, 0) = 1) then begin --  v_quantity  v_spec_quantity >0
              --     
              -- v_quantity -  ,      
              -- v_spec_quantity -    
              insert into DOCSPECEXT(dochead, articul, id, pos_number, mesuriment, rz,
                                     pack_quantity, pricerub, pricecur, barcode, comment, update_price)
                select :v_dochead, :v_articul, id, pos_number, mesuriment, rz,
                       pack_quantity * :v_quantity / :v_spec_quantity,
                       pricerub, pricecur, barcode, comment, 'F'
                  from DOCSPECEXT
                where dochead = :v_acthead and articul = :v_articul and rz = :v_asrt;
            end
          end
        end
      end
    end --     
    for select ds.articul, ds.custom,ds.country
      from docspec ds
      where ds.id_dochead=:v_indochead
    into :v_art,:v_custom,:v_country
    do
      update docspec dss set dss.country=:v_country, dss.custom=:v_custom where dss.id_dochead=:v_dochead and dss.articul=:v_art;
    --       
    update DOCHEAD set doc_state = -2 where id_dochead = :v_dochead;
  end

  --     (  )
  --               
  -- -               
  --           

  --       (    )
  --       
  --       
  if (is_neust = 1) then begin
    --      
    --  .. v_client_index,v_client_bank   
    --   ,       
    --     

    --         ,
    --       
    --          
    --     ,    
    --     

    --   
    v_dochead = gen_id(dochead_gen, 1);
    v_a = 0;
    while (v_a = 0) do begin
      v_chr = v_chr + 1;
      if (v_chr < 123)
        then v_docindex = ascii_char(v_chr);
        else v_docindex = ascii_char(96 + div(v_chr, 122)) || ascii_char(96 + mod(v_chr, 122));
      --     , ..     10 
      if (char_length(v_actindex || v_docindex) > 10) then begin
        exception E_LENGHT_DOCINDEX;
        exit;
      end else v_docindex = v_actindex || v_docindex;
      if (not exists(select 1 from DOCHEAD where shopindex = :v_shopindex and doctype = :v_doctype and docindex = :v_docindex))
        then v_a = 1;
    end
    insert into DOCHEAD(id_dochead, shopindex, dochead_filialindex, doctype, docindex, doc_date, client_index,
                        client2_index, client_bank, client2_bank, operation, cur_type, curs,doc_state,
                        manager, comment, ext_doctype, ext_docindex, ext_doc_date, legal_person)
      values(:v_dochead, :v_shopindex, :v_filialindex, :v_doctype, :v_docindex, :v_doc_date, :v_client_index,
             :v_client2_index, :v_client_bank, :v_client2_bank, :v_operation, :v_cur_type, :v_curs, -1, -- doc_state=-1 -   
             :v_manager, :v_dochead_comment, :v_ext_doctype, :v_ext_docindex, :v_ext_doc_date, :v_lp);
    update DOCHEAD_PARAMS
      set cfu = :v_cfu, activity_kind = :v_activity_kind, num_tn = :num_tn, date_tn = :date_tn,
          consignee = :consignee, consignor = :consignor,
          phys_address = :phys_address, phys_address1 = :phys_address1, lock_ret_oper = :V_LOCK_OPERATION
    where dochead = :v_dochead;

    update DOCHEAD set moddate = moddate + 0.00002 where id_dochead = :v_dochead; -- , ,     
    insert into DOCHEAD_LINK(dochead, basedochead) values(:v_dochead, :v_acthead); --   

    --       ..  

    v_pos_number = 1;

    --  
    for select articul, sum(quantity), iif(:v_maxminavg = 2, sum(pricerub * quantity), iif(:v_maxminavg = 0, max(pricerub), min(pricerub))),
               iif(:v_maxminavg = 2, sum(pricecur * quantity), iif(:v_maxminavg = 0, max(pricecur), min(pricecur)))
      from TMP_WRITEOFF
      where acthead = :v_acthead and indochead = -1
      group by articul
      into :v_articul, :v_quantity, :v_pricerub, :v_pricecur
    do begin
      --  v_pricerub  v_pricecur   -     
      if (v_maxminavg = 2) then begin
        v_pricerub = v_pricerub / v_quantity; v_pricecur = v_pricecur / v_quantity;
      end

      select mesuriment, rz, barcode, comment, quantity, pricerub_1, pricecur_1, taxhead --     (    )
        from DOCSPEC where id_dochead = :v_acthead and articul = :v_articul   --   
      into :v_mesuriment, :v_rz, :v_barcode, :v_comment, :v_spec_quantity, :v_pricerub1, :v_pricecur1, :v_taxhead;
      if (v_spec_quantity is null) then v_spec_quantity = 0;

      if (cmp_dbl_e(v_spec_quantity, 0) = 1) then begin --  v_spec_quantity>0
        --    
        v_doc_pack = v_mesuriment; v_doc_asrt = v_rz; --      
        if (v_rz = -1) then begin
          --         ,
          --           (   )
          v_a = null; v_p = null;
          select count(distinct t.asrt), min(t.asrt), count(distinct s.mesuriment), min(s.mesuriment)
            from TMP_WRITEOFF t
            left join DOCSPECEXT s on t.acthead = s.dochead and t.articul = s.articul and t.asrt = s.rz
            where t.acthead = :v_acthead and t.indochead = -1 and t.articul = :v_articul and s.rz is not null
          into :v_a, :v_doc_asrt, :v_p, :v_doc_pack; -- v_i>0  v_p>0    
          if (v_a > 1) then v_doc_asrt = -1; if (v_p > 1) then v_doc_pack = -1;
        end

        --      ,
        --     ,    docspec_bi   (quantity  pack_quantity)
        insert into DOCSPEC(id_dochead, articul, pos_number, mesuriment, rz,
                            quantity, pricerub, pricecur, pricerub_1, pricecur_1, taxhead, barcode, comment)
          values (:v_dochead, :v_articul, :v_pos_number, :v_doc_pack, :v_doc_asrt,
                  :v_quantity, :v_pricerub, :v_pricecur, :v_pricerub1, :v_pricecur1, :v_taxhead, :v_barcode, :v_comment);
        v_pos_number = v_pos_number + 1;

        if (v_doc_pack = -1 or v_doc_asrt = -1) then begin
          --       
          for select asrt, sum(quantity)
            from TMP_WRITEOFF
            where acthead = :v_acthead and indochead = -1 and articul = :v_articul
            group by asrt
          into :v_asrt, :v_quantity do begin
            select quantity from VW_ASRT_DOCSPEC(:v_acthead, :v_articul, :v_asrt, null, null)
              into :v_spec_quantity;

            if (cmp_dbl_e(v_quantity, 0) = 1 and cmp_dbl_e(v_spec_quantity, 0) = 1) then begin --  v_quantity  v_spec_quantity >0
              --     
              -- v_quantity -  ,      
              -- v_spec_quantity -    
              insert into DOCSPECEXT(dochead, articul, id, pos_number, mesuriment, rz,
                                     pack_quantity, pricerub, pricecur, barcode, comment, update_price)
                select :v_dochead, :v_articul, id, pos_number, mesuriment, rz,
                       pack_quantity * :v_quantity / :v_spec_quantity,
                       pricerub, pricecur, barcode, comment, 'F'
                  from DOCSPECEXT
                where dochead = :v_acthead and articul = :v_articul and rz = :v_asrt;
            end
          end
        end
      end
    end --     

    --       
    --           
    --               
    update DOCHEAD set doc_state = -2 where id_dochead = :v_dochead;
  end

  --      -   (      )
  v_dochead = null;
  select dlc.dochead
    from DOCHEAD_LINK_CORR dlc
    inner join DOCHEAD dh on dh.id_dochead = dlc.dochead and dh.dockind = 1
    where basedochead = :v_acthead
    rows 1 --   ,        
  into :v_dochead;
  if (v_dochead is not null)
    then update DOCHEAD set doc_state = -2 where id_dochead = :v_dochead;

  --    
  execute procedure ACT_WRITEOFF_CORRECT_SUM(:v_acthead);
  --    

   --      EDI
  --      ()
  select dh.doctype,dh.dochead_filialindex,dh.operation,dh.client_index from dochead dh where dh.id_dochead=:V_ACTHEAD into :v_dt,:v_df,:v_op,:v_ci;
  if (exists(select 1 from CONFIG where paramname = 'UseOVS' and boolparam = 'T') and
      exists(select 1 from OVS_STAGE where ovs_kind = 7 and is_use = 1) and
      exists(select 1 from DOCTYPE_FILIAL df
                        where doctype = :v_dt and kind = 19 and
                              filial_index = :v_df and is_used = 'T') and
      exists(select 1 from OPERATIONS where id_operation = :v_op and diadoc_fl = 'T') and
      ((exists (select 1
                     from DOCHEAD_LINK dl
                     inner join DOCHEAD dh on dh.id_dochead = dl.dochead and dh.dockind = 1
                     inner join OPERATIONS opp on opp.id_operation = dh.operation
                     left join CLIENTS c4 on c4.id_clients = dh.client_index
                     --left join DOCHEAD_PARAMS dpp on dpp.dochead = dh.id_dochead
                     left join CLIENTS c5 on c5.id_clients = dh.legal_person
                     left join TH_CLASSIF tc on tc.id_th_classif = dh.dochead_filialindex
                     left join CLIENTS c6 on c6.id_clients = tc.link_to_client
                     where dl.basedochead = :V_ACTHEAD and
                           (opp.opertype = 0 or
                            opp.opertype = 1)))
      )) then begin

    for select id from OVS_STAGE where is_use = 1 and ovs_kind = 7
      into :v_os_stage
    do if (not exists (select 1 from CONFIG where paramname = 'OVSUseForClients' and boolparam = 'T') or
           exists(select client_id from CLIENT_OVS where ovs_kind = :v_os_stage and client_id = :v_ci))
         then update or insert into DOCHEAD_OVS(dochead, ovs_kind, post_status) values(:V_ACTHEAD, :v_os_stage, 20);
  end
end^

COMMENT ON COLUMN DOCHEAD_PARAMS.LOCK_RET_OPER IS 
'  ,   '^

create or alter procedure AXAPTA_EXPDOCHEADER (
    DOCHEADKIND T_FID,
    DOCHEADTYPE T_FID,
    OPERATIONTYPEID T_FID,
    DOCFLOWID T_INT_VALUE,
    IMPOPERATIONTYPEID T_INT_VALUE,
    STOREID T_FID,
    DOCNUM T_STR20,
    DOCDATE T_DATE_NULL,
    CONTRAGENTID T_FID,
    LOCATIONIDFROM T_FID,
    LOCATIONIDTO T_FID,
    TOTALAMOUNT T_MONEY_NULL,
    TOTALQTY T_QUANTITY_NULL,
    comment T_COMMENT,
    DOCINVOICEID T_STR20,
    AGREEMENTID T_FID,
    ISCORRDOC T_INT_VALUE,
    STAGE_ID T_FID,
    CONTR T_FID,
    DOCFACTUREID T_STR20,
    DOCINVOICEDATE T_DATE_NULL,
    DOCFACTUREDATE T_DATE_NULL)
returns (
    ERR T_STRING100_NULL,
    DOCHEAD_ID T_FID)
AS
  declare variable err_ T_STR4096;
  declare variable out_dochead integer;
  declare variable v_docindex t_doc_index;
  declare variable v_user integer;
  declare variable v_basedh integer;
  declare variable NULLDATE T_DATE_NULL;
begin
  NULLDATE = '1900-01-02';--      
  if (DOCINVOICEDATE<=NULLDATE) then DOCINVOICEDATE = null;
  if (DOCFACTUREDATE<=NULLDATE) then DOCFACTUREDATE = null;
  DOCHEAD_ID = -1;
  select id from CUR_USER into :v_user;
  IsCorrDoc = coalesce(IsCorrDoc,0);
  if (not(coalesce(DocFlowId,-1) in (19,21,22,24,25,26,28,29,30,32,34,37,39,44,49))) then
  begin
    err='   DocFlowId';
    suspend;
    exit;
  end
  select dockind from axapta_docflow where docflowid=:DOCFLOWID into :DOCHEADKIND;
  if (docflowid=49) then
    DocHeadKind = -10;
  if (DocHeadKind is null and (DocFlowId<>49)) then
    err_ = '  DocHeadKind';
  if (DocHeadType is null) then
    if (err_ is null) then
      err_ = '  DocHeadType';
    else
      err_ = err_ || '/DocHeadType';
  if (trim(coalesce(DOCNUM,''))='') then
    if (err_ is null) then
      err_ = '  DOCNUM';
    else
      err_ = err_ || '/DOCNUM';
  if (OperationTypeId is null) then
    if (err_ is null) then
      err_ = '  OperationTypeId';
    else
      err_ = err_ || '/OperationTypeId';
  if (StoreId is null and (DocFlowId<>49)) then
    if (err_ is null) then
      err_ = '  StoreId';
    else
      err_ = err_ || '/StoreId';
  if (DocDate is null and (DocFlowId<>49)) then
    if (err_ is null) then
      err_ = '  DocDate';
    else
      err_ = err_ || '/DocDate';
  if (not ((coalesce(DOCFLOWID,-1) in (32,34,37,39,49)))) then
  begin
    if (coalesce(ContragentId,0)=0) then
      if (err_ is null) then
        err_ = '  ContragentId';
      else
        err_ = err_ || '/ContragentId';
  end
  if ((coalesce(DocHeadKind,-1) = 1 and (coalesce(DOCFLOWID,-1)<>21)) or (((coalesce(DOCFLOWID,-1) in (34,37,30,28))))) then
  begin
    if (coalesce(LocationIdFrom,0)=0) then
      if (err_ is null) then
        err_ = '  LocationIdFrom';
      else
        err_ = err_ || '/LocationIdFrom';
  end
  if (((coalesce(DocHeadKind,-1) in (0,6)) and not (coalesce(DOCFLOWID,-1) in (30,28))) or (((coalesce(DOCFLOWID,-1) in (32,39,21)))))  then
  begin
    if (coalesce(LocationIdTo,0)=0) then
      if (err_ is null) then
        err_ = '  LocationIdTo';
      else
        err_ = err_ || '/LocationIdTo';
  end
  if (TotalAmount is null and (DocFlowId<>49)) then
    if (err_ is null) then
      err_ = '  TotalAmount';
    else
      err_ = err_ || '/TotalAmount';
  if (not(DocHeadKind is null)) then
    if (docheadkind not in (0,1,6,-10)) then
    begin
      if (err_ is null) then
        err_ = '   DocHeadKind';
      else
        err_ = err_ || ',    DocHeadKind';
    end
  if (not(DocHeadType is null)) then
    if (not exists(select 1 from doctype dt where dt.id_doctype=:DocHeadType)) then
    begin
      if (err_ is null) then
        err_ = '   DocHeadType';
      else
        err_ = err_ || ',    DocHeadType';
    end
  if (not(OperationTypeId is null)) then
    if (not exists(select 1 from operations dt where dt.id_operation=:OperationTypeId)) then
    begin
      if (err_ is null) then
        err_ = '   OperationTypeId';
      else
        err_ = err_ || ',    OperationTypeId';
    end
  if ((not(StoreId is null)) and (DocFlowId<>49)) then
    if (not exists(select 1 from TH_Classif dt where dt.id_th_classif=:StoreId)) then
    begin
      if (err_ is null) then
        err_ = '   StoreId';
      else
        err_ = err_ || ',    StoreId';
    end
  if ((not ((coalesce(DOCFLOWID,-1) in (32,34,37,39,49)))) and (not(coalesce(ContragentId,0)=0))) then
  begin
    if (not exists(select 1 from clients cl where cl.id_clients=:ContragentId)) then
      if (err_ is null) then
        err_ = '  ContragentId';
      else
        err_ = err_ || ',   ContragentId';
  end
  if (((coalesce(DocHeadKind,-1) = 1 and coalesce(DOCFLOWID,-1)<>21) or (((coalesce(DOCFLOWID,-1) in (28,34,37,30))))) and (not(coalesce(LocationIdFrom,0)=0))) then
  begin
    if (not exists(select 1 from clients cl where cl.id_clients=:LocationIdFrom and cl.classif=:StoreId)) then
      if (err_ is null) then
        err_ = '  LocationIdFrom';
      else
        err_ = err_ || ',   LocationIdFrom';
  end
  if ((coalesce(DocHeadKind,-1) in (0,6) or (((coalesce(DOCFLOWID,-1) in (21,32,39)))) ) and (not(coalesce(LocationIdTo,0)=0)) and not (coalesce(DOCFLOWID,-1) in (28,30))) then
  begin
    if (not exists(select 1 from clients cl where cl.id_clients=:LocationIdTo and cl.classif=:StoreId)) then
      if (err_ is null) then
        err_ = '  LocationIdTo';
      else
        err_ = err_ || ',   LocationIdTo';
  end
  if ((not(coalesce(AgreementId,0)=0)) and (DocFlowId<>49)) then
    if (not exists(select 1 from CLIENT_AGREEMENTS cl where cl.id=:AgreementId)) then
      if (err_ is null) then
        err_ = '  AgreementId';
      else
        err_ = err_ || ',   AgreementId';
 /* if (not(DOCINVOICEID is null)) then
  begin
    DOCINVOICEID=trim(DOCINVOICEID);
    if (DOCINVOICEID<>'') then
    begin
      if (isnum(docinvoiceid)<>1) then
      begin
        if (err_ is null) then
            err_ = '   DOCINVOICEID';
          else
            err_ = err_ || ',    DOCINVOICEID';
      end
      else
        if (not exists(select 1 from dochead dt where dt.id_dochead=:docinvoiceid)) then
        begin
          if (err_ is null) then
            err_ = '   DOCINVOICEID';
          else
            err_ = err_ || ',    DOCINVOICEID';
        end
    end
  end  */
  if (err_ is null and (DocFlowId<>49)) then
    if (not exists(select 1 from ovs_axapta os where os.ovs_id=:stage_id and os.docflow_id=:docflowid and os.doctype_id=:DOCHEADTYPE and os.operation_id=:OperationTypeId)) then
    begin
      err_ = '             ';
    end
  if (char_length(err_) >= 100) then
    err = left(ERR_, 95) || '...';
  else
    err = err_;
  if (err is null) then
  begin
    if (DOCFLOWID=49) then
    begin
      select dp.dochead
        from dochead_params dp
        inner join dochead dh on dh.id_dochead=dp.dochead
        where dp.axapta_num=:docnum and dh.doctype=:DOCHEADTYPE and dh.operation=:operationtypeid rows 1
      into :out_dochead;
      if (out_dochead is null) then
        err = '  ';
      else
      begin
        docinvoiceid = iif(trim(coalesce(docinvoiceid,''))='',null,docinvoiceid);
        DocFactureId = iif(trim(coalesce(DocFactureId,''))='',null,DocFactureId);
        update dochead dh set dh.ext_docindex = :docinvoiceid, dh.ext_doc_date = :DocInvoiceDate where dh.id_dochead = :out_dochead;
        update dochead_params dp set dp.num_tn = :DocFactureId, dp.date_tn = :docfacturedate
        where dp.dochead = :out_dochead;
      end
      suspend;
      exit;
    end
    if (DOCFLOWID=21) then
      locationidfrom=locationidto;
    if (DOCFLOWID=28) then
      locationidto=locationidfrom;
    if (DOCFLOWID in (32,39)) then
    begin
      ContragentId=contr;
      ContragentId= coalesce(ContragentId,0);
      if (ContragentId=0) then
        ContragentId=-2;
      if (ContragentId<>-2) then
        if (not exists(select 1 from clients c where c.id_clients=:contragentid)) then
        begin
          err = '  ContragentId';
          suspend;
          exit;
        end
    end

    if (docflowid in (34,37) or (ContragentId=-2 and docflowid in (32,39))) then
      select client_id
        from ovs_axapta os
        where os.ovs_id=:stage_id and os.docflow_id=:docflowid and os.doctype_id=:DOCHEADTYPE and os.operation_id=:OperationTypeId
      into :CONTRAGENTID;
    if ((DocFlowId<>49) and exists(select 1
      from dochead_params dp
      inner join dochead dh on dh.id_dochead=dp.dochead
      where dp.axapta_num=:docnum and dh.accept='T' and dh.doctype=:DOCHEADTYPE and dh.operation=:operationtypeid)) then
    begin
      err = '  ';
      suspend;
      exit;
    end
    if (exists(select 1
        from dochead_params dp
        inner join dochead dh on dh.id_dochead=dp.dochead
        where dp.axapta_num=:docnum and dh.doctype=:DOCHEADTYPE and dh.operation=:operationtypeid and
             (dh.client_index=coalesce(:contr,-1) or (:DOCFLOWID not in (32,39))))) then
    begin
      select dp.dochead,dh.docindex
        from dochead_params dp
        inner join dochead dh on dh.id_dochead=dp.dochead
        where dp.axapta_num=:docnum and dh.doctype=:DOCHEADTYPE and dh.operation=:operationtypeid rows 1
      into :out_dochead, :v_docindex;
      delete from docspec_ovs dov where dov.dochead=:out_dochead;
      delete from docspec ds where ds.id_dochead=:out_dochead;
      delete from dochead_agreement_link where dochead = :out_dochead;
    end
    else
    begin
      out_dochead = gen_id(dochead_gen, 1);
      select docindex from GET_NEW_DOCINDEX(1, :DocHeadType, :DocDate) into :v_docindex;
    end
    dochead_id = out_dochead;     
    if (DOCFLOWID=30) then
      locationidto = locationidfrom;
    update or insert into DOCHEAD(id_dochead, shopindex, dochead_filialindex, doctype, docindex, dockind,
                          doc_date, client_index, client2_index, operation, manager, comment)
      values(:out_dochead, 1, :storeid, :DocHeadType, :v_docindex, :DocHeadKind,
             :DocDate, :ContragentId, iif(:DocHeadKind=1,:locationidfrom,:locationidto), :OperationTypeId, :v_user, :comment);
    if (DOCFLOWID=19) then
    begin
      docinvoiceid = iif(trim(coalesce(docinvoiceid,''))='',null,docinvoiceid);
      DocFactureId = iif(trim(coalesce(DocFactureId,''))='',null,DocFactureId);
      update dochead dh set dh.ext_docindex = :docinvoiceid, dh.ext_doc_date = :DocInvoiceDate where dh.id_dochead = :out_dochead;
      update dochead_params dp set dp.num_tn = :DocFactureId, dp.date_tn = :docfacturedate
        where dp.dochead = :out_dochead;
    end
    if (not(coalesce(AgreementId,0)=0)) then
      insert into dochead_agreement_link(dochead,agreement) values(:out_dochead,:AgreementId);
    update dochead_params dp set dp.axapta_num=:docnum where dp.dochead=:out_dochead;
    update or insert into dochead_ovs(dochead,ovs_kind,bool_p,post_status) values(:out_dochead,:stage_id,'F',5);
    if (trim(coalesce(docinvoiceid,''))<>'') then
      select dp.dochead from dochead_params dp where dp.axapta_num=:docinvoiceid rows 1
      into :v_basedh;
    if (not (v_basedh is null)) then
      update or insert into DOCHEAD_LINK(dochead,basedochead) values(:out_dochead,:v_basedh);
    delete from docspec_ovs dov where dov.dochead=:out_dochead;
  end
  suspend;
end^

ALTER TABLE DOCHEAD_PARAMS DROP LOCK_DATE_TN^

ALTER TABLE DOCHEAD_PARAMS DROP LOCK_NUM_TN^

ALTER TABLE DOCHEAD_PARAMS DROP LOCK_EXT_DOCINDEX^

ALTER TABLE DOCHEAD_PARAMS DROP LOCK_EXT_DOC_DATE^

set term ; ^

insert into PROPERTIES(PROP_ID,PROP_CLASS,PROP_DESCRIPTION)
  select (select max(prop_id)+1 from PROPERTIES),'ACCEPT_CHANGE_RETOP','     '
    from RDB$DATABASE
    where not exists (select 1 from PROPERTIES where prop_class='ACCEPT_CHANGE_RETOP');
insert into PMODPROPERTY (PROGMOD_ID,PROP_ID,PMODPROP_DEFVALUE)
  select prm.PROGMOD_ID,pr.PROP_ID,'F'
    from PROPERTIES pr, PROGMOD prm
    where pr.PROP_CLASS='ACCEPT_CHANGE_RETOP' and
          prm.PROGMOD_CLASS='S_DocsMain' and
          not exists (select 1 from PMODPROPERTY where
                        progmod_id=prm.progmod_id and
                        prop_id=pr.prop_id);



--axapta end


commit work;
